GanttComponent

9 Jul 202624 minutes to read

ejs-gantt represents the VueJS Gantt Component.

<ejs-gantt :dataSource='data' allowSelection='true' allowSorting='true'></ejs-gantt>

Properties

addDialogFields AddDialogFieldSettingsModel[]

Defines the tabs and fields to be displayed in the add dialog.
If not specified, the fields will be derived from the taskSettings and columns values.

    <template>
        <ejs-gantt :addDialogFields="addDialogFields"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                addDialogFields : [
                    { type: 'General', headerText: 'General', fields: ['TaskID', 'TaskName'] },
                    { type: 'Resources' },
                    { type: 'Dependency' },
                    { type: 'Notes'}
                ];
            }
        provide: { }
    }});
</script>

Defaults to []

allowExcelExport boolean

Enables exporting the Gantt chart to Excel (.xlsx) and CSV formats.
When set to true, users can export the chart data.

Defaults to false

allowFiltering boolean

Enables or disables filtering functionality in the Gantt chart.

Defaults to false

allowKeyboard boolean

Enables or disables keyboard interactions in the Gantt chart.

Defaults to true

allowParentDependency boolean

Specifies whether dependency connections are supported for parent tasks.
Only allows dependencies between tasks belonging to different parents.
Dependencies within the same parent are not supported.

Defaults to true

allowPdfExport boolean

If allowPdfExport set to true, then it will allow the user to export Gantt chart to PDF file.

Defaults to false

allowReordering boolean

If allowReordering is set to true, Gantt chart columns can be reordered.
Reordering can be done by drag and drop of a particular column from one index to another index.

Defaults to false

allowResizing boolean

Enables column resizing in the Gantt chart when allowResizing is set to true.
When enabled, users can adjust the width of columns by dragging the column borders.

Defaults to false

allowRowDragAndDrop boolean

If allowRowDragAndDrop set to true, then it will allow the user to perform row drag and drop action in Gantt chart.

Defaults to false

allowSelection boolean

Specifies whether to enable row selection in the Gantt chart. When enabled, selected rows are highlighted.

Defaults to true

allowSorting boolean

If allowSorting is set to true, it enables sorting of Gantt chart tasks when the column header is clicked.

Defaults to false

allowTaskbarDragAndDrop boolean

Specifies whether taskbar drag and drop is enabled in the Gantt chart.

Defaults to false

allowTaskbarOverlap boolean

Specifies whether taskbars can overlap in the Gantt chart. To enable overlapping behavior, use this property along with enableMultiTaskbar.

Defaults to true

allowUnscheduledTasks boolean

Enables or disables the rendering of unscheduled tasks in the Gantt chart.
When allowUnscheduledTasks set to true, unscheduled tasks will be displayed in the chart.

Defaults to false

autoCalculateDateScheduling boolean

Specifies whether to auto calculate the start and end dates based on factors such as working time, holidays, weekends, and task dependencies.

Defaults to true

autoFocusTasks boolean

Specifies whether to automatically scroll the corresponding taskbar into view when a task is selected.

Defaults to true

autoUpdatePredecessorOffset boolean

Determines whether to automatically validate and update predecessor offsets in the IPredecessor collection and columns during initial load.
When true, ensures data consistency with rendering validations.

Defaults to false

baselineColor string

Specifies the color of the baseline bar in the Gantt chart.

    <template>
        <ejs-gantt :renderBaseline="true" baselineColor='red'> </ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                labelSettings: {
                    leftLabel: 'Task ID: ${taskData.TaskID}',
                    rightLabel:'Progress Value: ${taskData.Progress}',
                    taskLabel: '${Progress}%'
                },
            },
        }
        provide: { }
    }});
</script>

Defaults to null

baselineTemplate string|Function

.
Accepts an element ID selector, HTML string, or function returning string or HTMLElement.
Defines a custom template for rendering baseline bars in the Gantt chart.

Defaults to null

calendarSettings CalendarSettingsModel

Defines the calendar configuration for the project, including working times, holidays, and task-specific calendars.
This setting enables customization of scheduling behavior across the Gantt chart, including:

  • Global working hours and non-working days
  • Holiday definitions with localized labels
  • Task-level calendar overrides via taskFields.calendarId

Defaults to {}

collapseAllParentTasks boolean

Defines whether all root tasks should be rendered in a collapsed state. When collapseAllParentTasks set to true, all parent tasks will be collapsed by default.

Defaults to false

columnMenuItems []

columnMenuItems defines both built-in and custom menu items for the Gantt chart column menu.



The available built-in items are,

  • ColumnChooser - To show/hide the TreeGrid columns.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the size of the current column.
  • Filter - Displays filter options based on the filterSettings property.

Defaults to null

columnMenuModule ColumnMenu

The columnMenuModule is used to manage and customize the column menu in the Gantt chart.

columns Column[]|string[]|ColumnModel[]

Defines the collection of columns displayed in the Gantt chart grid.
If the columns declaration is empty, the columns are automatically populated based on the taskSettings values.

    <template>
        <ejs-gantt :columns = "columns"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                columns: [
                    { field: 'TaskID', width: '150', headerText: 'Task ID', headerTextAlign: 'Left' allowFiltering: false },
                    { field: 'TaskName', clipMode: 'EllipsisWithTooltip' allowEditing: true, hideAtMedia: '(min-width: 700px)' },
                    { field: 'Duration', edittype: 'stringedit', allowReordering: true, maxWidth: '400' },
                    { field: 'Progress', textAlign: 'Right', allowResizing: false , visible: true, format: 'C' },
                    { field: 'StartDate', width: '250', allowSorting: false, minWidth: '200' }
                ]
            }
        provide: { }
    }});
</script>

Defaults to []

connectorLineBackground string

Specifies the background color of dependency (connector) lines in the Gantt chart.
Accepts any valid CSS color value (for example: “red”, “#FF5733”, “rgb(255, 0, 0)”).

Defaults to null

connectorLineWidth number

Defines the width of the dependency lines in the Gantt chart.
The value should be a positive integer, representing the thickness of the lines.

Defaults to 1

contextMenuItems ContextMenuItem[]|ContextMenuItemModel[]

Defines the built-in and custom items that appear in the context menu of the Gantt chart.
You can use this property to control the content and functionality of the right-click context menu.

    <template>
        <ejs-gantt :contextMenuItems="contextMenuItems"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, ContextMenu } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                contextMenuItems: ['AutoFitAll', 'AutoFit', 'TaskInformation', 'DeleteTask', 'Save', 'Cancel', 'SortAscending', 'SortDescending', 'Add', 'DeleteDependency', 'Convert',
                { text: 'Collapse the Row', target: '.e-content', id: 'collapserow' },
                { text: 'Expand the Row', target: '.e-content', id: 'expandrow' },
                ],
            }
        provide: {gantt: [ ContextMenu ]}
    }});
</script>

Defaults to null

contextMenuModule ContextMenu

The contextMenuModule is responsible for managing and invoking the context menu in the Gantt chart.
It provides the functionality to display and interact with the context menu, which can be customized using the contextMenuItems property.

criticalPathModule CriticalPath

The criticalPathModule is used to determine the critical path in the Gantt chart.
It identifies the sequence of tasks that directly affect the project’s duration and highlights them.

currentZoomingLevel ZoomTimelineSettings

Specifies the current zooming level of the Gantt chart.

dataSource Object[]|DataManager|Object

Defines the data source for the Gantt chart, which is used to render rows and tasks.
The dataSource can be an array of JavaScript objects, an instance of DataManager, or a single object.
The array of objects should contain the task data with properties such as TaskID, TaskName, StartDate, EndDate, etc.
This allows dynamic binding of tasks and their relationships (e.g., dependencies, subtasks, progress) to the Gantt chart.

    <template>
        <ejs-gantt :dataSource="data"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                // Hierarchical data binding.
                data: [
                    {
                        TaskID: 1,
                        TaskName: 'Project Initiation',
                        StartDate: new Date('04/02/2019'),
                        EndDate: new Date('04/21/2019'),
                        subtasks: [
                            { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 }
                        ]
                    },
                ],
                // Self-referential data binding (Flat data).
                data = [
                    { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
                    { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50, ParentId: 1 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50, ParentId: 1 }
                ];
                // Remote data
                data: new DataManager({
                    url: 'https://ej2services.syncfusion.com/production/web-services/api/GanttData',
                    adaptor: new WebApiAdaptor,
                    crossDomain: true
                }),
            }
        provide: {}
    }});
</script>

Defaults to []

dateFormat string

Specifies the date format for displaying dates in the Gantt chart, including in tooltips and grid cells.
By default, the format is determined based on the current culture/locale settings.

dayMarkersModule DayMarkers

The dayMarkersModule is used to manage and manipulate event markers in the Gantt chart.
It allows customization of how markers are displayed on specific days, helping to highlight important dates or milestones.

dayWorkingTime DayWorkingTimeModel[]

Defines the customized working time for the project to ensure accurate task scheduling, and works only when the timeline is configured with topTier.unit as ‘Day’ and bottomTier.unit as ‘Hour’ or when timelineViewMode is set to ‘Hour’ or ‘Day’.

    <template>
        <ejs-gantt :dayWorkingTime="dayWorkingTime"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                dayWorkingTime: [{ from: 9, to: 18 }],
            }
        provide: {}
    }});
</script>

disableHtmlEncode boolean

If disableHtmlEncode is set to true, the Gantt component disables HTML entity encoding across the Gantt content, allowing custom HTML elements to be rendered.

Defaults to true

durationUnit DurationUnit

durationUnit Specifies the duration unit for each task. The available options are:

  • day: Sets the duration unit to day.
  • hour: Sets the duration unit to hour.
  • minute: Sets the duration unit to minute.

Defaults to day

editDialogFields EditDialogFieldSettingsModel[]

Defines the tabs and fields to be displayed in the edit dialog.
If not specified, the fields will be derived from the taskSettings and columns values.

    <template>
        <ejs-gantt :editDialogFields="editDialogFields"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                editDialogFields : [
                    { type: 'General', headerText: 'General', fields: ['TaskID', 'TaskName'] },
                    { type: 'Resources' },
                    { type: 'Dependency' },
                    { type: 'Notes'}
                ];
            }
        provide: { }
    }});
</script>

Defaults to []

editModule Edit

The editModule handles the manipulation of Gantt chart records, including editing, updating, and deleting tasks.

editSettings EditSettingsModel

Configures the edit settings for the Gantt chart, such as enabling or disabling task modifications.

    <template>
        <ejs-gantt :editSettings= "editSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, Edit } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                allowAdding: true,
                allowEditing: true,
                allowDeleting: true,
                allowTaskbarEditing: true,
                mode:'Auto',
                newRowPosition: 'Top',
                showDeleteConfirmDialog: true
            },
        }
        provide: { gantt: [ Edit ] }
    }});
</script>

Defaults to { allowAdding: false, allowEditing: false, allowDeleting: false, mode:’Auto’,showDeleteConfirmDialog: false }

emptyRecordTemplate string|Function

Defines a custom template to display when the Gantt chart has no records.
This template replaces the default empty record message and can include text, HTML elements, or images.
Accepts either a template string or an HTML element ID.

Defaults to null

enableAdaptiveUI boolean

Specifies whether to enable an adaptive UI mode, which optimizes the layout of pop-ups for filtering, editing, and other features on smaller screens, such as mobile devices. *

Defaults to false

enableAutoWbsUpdate boolean

Enables the automatic update of WBS codes when performing actions like sorting, filtering, row drag and drop, and other grid operations that change the task order or hierarchy.
When set to true, the Gantt component will refresh and regenerate the WBS codes dynamically after such actions to ensure the codes remain in sync with the current task structure.

Defaults to false

enableContextMenu boolean

If enableContextMenu is set to true, enables the context menu in the Gantt chart.
The context menu provides additional actions that can be accessed by right-clicking on Gantt chart elements

Defaults to false

enableCriticalPath boolean

Enables the highlighting of critical tasks in the Gantt Chart that directly affect the project’s end date.
When enabled, tasks that are critical to the project timeline will be visually distinguished by colours.

Defaults to false

enableHover boolean

If enableHover is set to true, it enables hover in the Gantt chart and highlights the rows, chart rows, header cells and timeline cells.

Defaults to false

enableHtmlSanitizer boolean

Specifies whether to display or remove the untrusted HTML values in the TreeGrid component.
If enableHtmlSanitizer set to true, any potentially harmful strings and scripts are sanitized before rendering.

Defaults to true

enableImmutableMode boolean

If enableImmutableMode is set to true, the Gantt Chart will reuse existing rows from previous results instead of
performing a full refresh when Gantt actions are executed.

Defaults to false

enableInfiniteTimelineScroll boolean

Enables infinite horizontal scrolling for the Gantt timeline by dynamically
extending the timeline when the scroll reaches the end.

Defaults to false

enableMultiTaskbar boolean

Enables the rendering of child taskbars on the parent row when it is in a collapsed state in the Gantt chart.

Defaults to false

enablePersistence boolean

Enable or disable persisting component’s state between page reloads.

Defaults to false

enablePredecessorValidation boolean

If enablePredecessorValidation is set to true, enables validation for predecessor links in the Gantt chart.

Defaults to true

enableRtl boolean

Enable or disable rendering component in right to left direction.

Defaults to false

enableTimelineVirtualization boolean

Enables better performance for projects with a large time span by initially rendering only the visible timeline cells when enableVirtualization is enabled.
Subsequent cells are loaded on horizontal scrolling.

Defaults to false

enableUndoRedo boolean

enableUndoRedo enables or disables the undo/redo functionality in the Gantt chart.
Enables undo and redo in the Gantt chart. When set to true, users can
revert or reapply recent changes.

Defaults to false

enableVirtualMaskRow boolean

Specifies whether to display a shimmer effect during scrolling in the virtual scrolling feature when enableVirtualization is enabled. If disabled, a spinner is shown instead of the shimmer effect.

Defaults to true

enableVirtualization boolean

If enableVirtualization is set to true, the Gantt chart will render only the rows visible within the viewport.
and load subsequent rows as the user scrolls vertically. This improves performance when dealing with large datasets.

Defaults to false

enableWBS boolean

Enables Work Breakdown Structure (WBS) functionality in the Gantt Chart.
When set to true, the Gantt Chart automatically generates WBS codes based on the task hierarchy.
A dedicated WBS Code column will be shown to represent the task structure.
Additionally, if task dependencies (predecessors) are mapped in the data source, a WBS Predecessor column will also be displayed to reflect dependency information using WBS codes.

Defaults to false

eventMarkers EventMarkerModel[]

Defines the events and milestones along the project timeline.
These event markers indicate significant events or milestones throughout the project’s duration.

    <template>
        <ejs-gantt :eventMarkers = "eventMarkers"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, DayMarkers  } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                eventMarkers: [
                {
                    day: '04/10/2019',
                    cssClass: 'e-custom-event-marker',
                    label: 'Project approval and kick-off'
                }]
            },
        }
        provide: { gantt: [ DayMarkers ] }
    }});
</script>

Defaults to []

excelExportModule ExcelExport

The excelExportModule is used for exporting Gantt data to an Excel file.
This module provides the functionality to export task data, dependencies, and other Gantt-related information in Excel format.

filterModule Filter

The filterModule is used to manage and apply filtering operations in the Gantt chart.

filterSettings FilterSettingsModel

Configures the filter settings for the Gantt chart, enabling users to filter tasks based on specific columns or criteria.
The filterSettings property allows customization of filter behavior, such as which columns to filter and the filter type.

    <template>
        <ejs-gantt :filterSettings="filterSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, Filter } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                filterSettings: {
                    columns: [{ field: 'TaskName', matchCase: false, operator: 'startswith', predicate: 'and', value: 'Identify' },{ field: 'TaskID', matchCase: false, operator: 'equal', predicate: 'and', value: 2 }],
                    ignoreAccent: true
               },
            },
        }
        provide: { gantt: [ Filter  ] }
    }});
</script>

Defaults to {columns: [], type: ‘Menu’ }

frozenColumns number

Specifies the number of columns that should remain visible and fixed on the left side of the Gantt during horizontal scrolling.
This feature ensures key columns, such as identifiers, stay visible while users scroll through data.

Defaults to 0

gridLines GridLine

Configures the grid lines displayed in the TreeGrid and Gantt chart.
The gridLines property allows customization of the type of grid lines to be shown, either horizontal, vertical, both or none.

  • Both: Displays both horizontal and vertical grid lines.
  • None: Hides both horizontal and vertical grid lines.
  • Horizontal: Displays only horizontal grid lines.
  • Vertical: Displays only vertical grid lines.
  • Default: Adjusts line visibility based on the theme.

Defaults to ‘Horizontal’

height number|string

Defines the height of the Gantt component container.
The height property can be set to a specific value (in pixels or percentage) or set to ‘auto’ for automatic height adjustment based on content.

Defaults to ‘auto’

highlightWeekends boolean

If highlightWeekends is set to true, it highlights all weekend days in the week-day timeline mode.
This makes weekends visually distinct in the timeline view.

Defaults to false

holidays HolidayModel[]

Defines holidays within the project timeline, allowing you to mark specific dates as holidays.
This helps in accounting for non-working days in scheduling and task planning.

    <template>
        <ejs-gantt :holidays = "holidays"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, DayMarkers  } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                holidays: [{
                    from: "04/04/2019",
                    to:"04/05/2019",
                    label: " Public holidays",
                    cssClass:"e-custom-holiday"
                }]
            },
        }
        provide: { gantt: [ DayMarkers ] }
    }});
</script>

Defaults to []

includeWeekend boolean

Specifies whether weekend days are considered working days in the Gantt chart.
When includeWeekend is set to true, weekends (Saturday and Sunday) are treated as regular working days.

Defaults to false

keyboardModule KeyboardEvents

The keyboardModule is responsible for managing keyboard interactions in the Gantt chart.
It handles events such as navigating, selecting, and performing actions using the keyboard.

labelSettings LabelSettingsModel

Configures the labels displayed on the right, left, and inside the taskbars in the Gantt chart.

    <template>
        <ejs-gantt :labelSettings="labelSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                labelSettings: {
                    leftLabel: 'Task ID: ${taskData.TaskID}',
                    rightLabel:'Progress Value: ${taskData.Progress}',
                    taskLabel: '${Progress}%'
                },
            },
        }
        provide: { }
    }});
</script>

loadChildOnDemand boolean

Gets or sets whether to load child records on demand in remote data binding. When loadChildOnDemand set to true, child records are loaded only when expanded, and parent records are rendered in a collapsed state initially.

Defaults to true

loadingIndicator LoadingIndicatorModel

Specifies the type of loading indicator to display during scrolling action in the virtual scrolling feature when enableVirtualization is enabled.

Defaults to {indicatorType: ‘Spinner’}

locale string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

Defaults to ’’

milestoneTemplate string|Function

Defines a custom template for rendering milestone tasks in the Gantt chart. This template allows you to customize the appearance of milestone tasks.

    <template>
        <ejs-gantt :milestoneTemplate="'milestoneTemplate'">
             <template v-slot:milestoneTemplate="{data}">
                <div class="e-gantt-milestone" style="position:absolute;">
                    <div class="e-milestone-top" style="border-right-width:15px;border-left-width:15px;border-bottom-width:15px;"></div>
                    <div class="e-milestone-bottom" style="top:15px;border-right-width:15px; border-left-width:15px; border-top-width:15px;"></div>
                </div>
            </template>
        </ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                labelSettings: {
                    leftLabel: 'Task ID: ${taskData.TaskID}',
                    rightLabel:'Progress Value: ${taskData.Progress}',
                    taskLabel: '${Progress}%'
                },
            },
        }
        provide: { }
    }});
</script>

Defaults to null

parentTaskbarTemplate string|Function

Defines a custom template for rendering parent task bars in the Gantt chart. This template allows you to customize the appearance of parent task bars.

    <template>
        <ejs-gantt :parentTaskbarTemplate="'parentTaskbarTemplate'">
             <template v-slot:parentTaskbarTemplate="{data}">
        <div class="e-gantt-parent-taskbar-inner-div e-gantt-parent-taskbar" style="height:100%">
                <div class="e-gantt-parent-progressbar-inner-div e-gantt-parent-progressbar" 
                       style="width:${ganttProperties.progressWidth}px;height:100%">
                  <span class="e-task-label"
                       style="position:absolute;top:5px;font-size:12px;text-overflow:ellipsis;height:90%;overflow:hidden;">
                  </span>
                 </div>
               </div>
            </template>
        </ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                labelSettings: {
                    leftLabel: 'Task ID: ${taskData.TaskID}',
                    rightLabel:'Progress Value: ${taskData.Progress}',
                    taskLabel: '${Progress}%'
                },
            },
        }
        provide: { }
    }});
</script>

Defaults to null

pdfExportModule PdfExport

The pdfExportModule is used for exporting the Gantt chart data to a PDF format.
This module provides functionality for exporting the entire chart or specific data to a PDF document.

projectEndDate Date|string

Defines the end date of the project. If the projectEndDate is not set, it will be automatically calculated based on the data source.
The date can be provided as a Date object or a string in a valid date format.

Defaults to null

projectStartDate Date|string

Defines the start date of the project. If the projectStartDate is not set, it will be automatically calculated based on the data source.
The date can be provided as a Date object or a string in a valid date format.

Defaults to null

query Query

Defines an external Query
that will be executed in conjunction with data processing to filter, sort the data.
This allows for advanced data manipulation before binding the data to the Gantt chart.

<template>
    <ejs-gantt
        id="Gantt"
        height="450px"
        :data-source="dataSource"
        :query="customQuery"
        :task-fields="taskFields"
        :label-settings="labelSettings">
    </ejs-gantt>
</template>

<script>
import Vue from "vue";
import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
import { DataManager, Query, WebApiAdaptor } from '@syncfusion/ej2-data';

Vue.use(GanttPlugin);

export default Vue.extend({
    data: function() {
        return {
            dataSource: new DataManager({
                url: 'https://ej2services.syncfusion.com/production/web-services/api/GanttData',
                adaptor: new WebApiAdaptor(),
                crossDomain: true
            }),

            customQuery: new Query()
                .addParams('ej2Gantt', 'test'),

            taskFields: {
                id: 'TaskID',
                name: 'TaskName',
                startDate: 'StartDate',
                endDate: 'EndDate',
                duration: 'Duration',
                progress: 'Progress',
                parentID: 'ParentID'
            },

            labelSettings: { leftLabel: 'TaskName' }
        };
    }
});
</script>

Defaults to null

readOnly boolean

If readOnly is set to true, the Gantt chart becomes read-only, meaning tasks and other elements cannot be edited.
This setting disables all editing features, including task updates, dependency management, and any editing acions.

Defaults to false

renderBaseline boolean

If renderBaseline is set to true, baselines will be rendered for tasks in the Gantt chart.
Baselines provide a visual reference to track the planned vs. actual progress of tasks.

Defaults to false

resourceFields ResourceFieldsModel

Defines the mapping properties to extract resource values, such as id, name, unit, and group from the resource collection in the Gantt chart.
This helps to map data from a custom resource collection to the appropriate fields for resource allocation.

resourceIDMapping string

Defines the mapping property to retrieve the resource ID value from the resource collection.
This is used to map the resource ID from the resource data to the Gantt chart for resource allocation.

<template>
    <ejs-gantt
        :data-source="data"
        :task-fields="taskFields"
        :resource-fields="resourceFields"
        :resources="resources"
        :label-settings="labelSettings">
    </ejs-gantt>
</template>

<script>
import Vue from "vue";
import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";

Vue.use(GanttPlugin);

export default Vue.extend({
    data: function() {
        return {
            data: [
                { TaskID: 1, TaskName: 'Task 1', StartDate: new Date('2025-01-01'), Duration: 5, resources: [1] },
                { TaskID: 2, TaskName: 'Task 2', StartDate: new Date('2025-01-03'), Duration: 4, resources: [1, 2] }
            ],
            resources: [
                { resourceId: 1, resourceName: 'Martin' },
                { resourceId: 2, resourceName: 'Rose' }
            ],
            taskFields: { resourceInfo: 'resources' },
            resourceFields: {
                id: 'resourceId',     // Maps resource ID field → conceptually resourceIDMapping
                name: 'resourceName'  // Maps resource Name field → conceptually resourceNameMapping
            },
            labelSettings: { rightLabel: 'resources' }
        };
    }
});
</script>

Defaults to null

resourceNameMapping string

Defines the mapping property to retrieve the resource name value from the resource collection.
This is used to map the resource name from the resource data to the Gantt chart for task allocation.

<template>
    <ejs-gantt
        :data-source="data"
        :task-fields="taskFields"
        :resource-fields="resourceFields"
        :resources="resources"
        :label-settings="labelSettings">
    </ejs-gantt>
</template>

<script>
import Vue from "vue";
import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";

Vue.use(GanttPlugin);

export default Vue.extend({
    data: function() {
        return {
            data: [
                { TaskID: 1, TaskName: 'Task 1', StartDate: new Date('2025-01-01'), Duration: 5, resources: [1] },
                { TaskID: 2, TaskName: 'Task 2', StartDate: new Date('2025-01-03'), Duration: 4, resources: [1, 2] }
            ],
            resources: [
                { resourceId: 1, resourceName: 'Martin' },
                { resourceId: 2, resourceName: 'Rose' }
            ],
            taskFields: { resourceInfo: 'resources' },
            resourceFields: {
                id: 'resourceId',     // Maps resource ID field → conceptually resourceIDMapping
                name: 'resourceName'  // Maps resource Name field → conceptually resourceNameMapping
            },
            labelSettings: { rightLabel: 'resources' }
        };
    }
});
</script>

Defaults to null

resources object[]

Specifies the collection of resources assigned to the project.

Defaults to []

rowDragAndDropModule RowDD

The rowDragAndDropModule manages the row reordering functionality in the Gantt chart.
It allows users to drag and drop rows to reorder tasks within the Gantt chart view.

rowHeight number

Defines the height of grid and chart rows in the Gantt chart.
This property sets the vertical space allocated for each task or row, allowing customization of row sizes.

Defaults to 36

searchSettings SearchSettingsModel

Configures the search functionality within the Gantt chart.

    <template>
        <ejs-gantt :searchSettings="searchSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, Filter  } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                searchSettings: { fields: ['TaskName'], operator: 'contains', key: 'List', ignoreCase: true, hierarchyMode: 'Parent'}
            },
        }
        provide: { gantt: [ Filter ] }
    }});
</script>

segmentData object[]

Specifies the array of segment objects assigned to tasks in the Gantt chart.
Each segment represents a portion of the taskbar, allowing for visual representation of different phases or sub-tasks within a single task.

Defaults to []

selectedRowIndex number

The selectedRowIndex allows you to specify the index of the row to be selected at the time of initial rendering.
It can also be used to get the currently selected row index after selection.
A value of -1 indicates no row is selected.

Defaults to -1

selectionModule Selection

The selectionModule is used to manipulate selection operation in the Gantt chart.

selectionSettings SelectionSettingsModel

Configures the settings for selection in the Gantt chart.

    <template>
        <ejs-gantt :selectionSettings="selectionSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, Selection } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                selectionSettings: {
                    mode: 'Row',
                    type: 'Multiple'
                }
            },
        }
        provide: { gantt: [ Selection ] }
    }});
</script>

Defaults to {mode: ‘Row’, type: ‘Single’}

showColumnMenu boolean

If showColumnMenu set to true, enables the column menu options for each column header in the Gantt chart.

Defaults to false

showInlineNotes boolean

To show notes column cell values inside the cell or in tooltip.

Defaults to false

showOverAllocation boolean

If showOverAllocation set to true, enables the rendering of the overallocation container in the Gantt chart.

Defaults to false

sortModule Sort

The sortModule is used to manipulate sorting operation in Gantt.

sortSettings SortSettingsModel

Configures the sorting options for the Gantt chart.
When set, it defines how tasks are sorted based on the specified columns.

    <template>
        <ejs-gantt :sortSettings="sortSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, Sort } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                sortSettings: { columns: [{ field: 'TaskID', direction: 'Descending' }], allowUnsort: true },
            },
        }
        provide: { gantt: [ Sort ] }
    }});
</script>

Defaults to {columns:[]}

splitterSettings SplitterSettingsModel

Configures the splitter settings for the Gantt chart.

    <template>
        <ejs-gantt :splitterSettings="splitterSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                splitterSettings:{
                    position: "50%",
                    minimum: "200",
                    separatorSize: 5,
                    view: 'Default'
                },
            },
        }
        provide: { }
    }});
</script>

The position takes precedence over columnIndex when both defined.

taskFields TaskFieldsModel

Defines the mapping properties used to extract task-related values—such as ID, start date, end date, duration, and progress—from the data source.
This ensures that the Gantt chart correctly maps the provided data to the corresponding task fields and renders them accurately.

    <template>
        <ejs-gantt :taskFields = "taskFields"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                taskFields: {
                    id: 'TaskID',
                    name: 'TaskName',
                    startDate: 'StartDate',
                    duration: 'Duration',
                    dependency: 'Predecessor',
                    progress: 'Progress',
                    baselineStartDate: 'BaselineStartDate',
                    baselineEndDate: 'BaselineEndDate',
                    durationUnit: 'DurationUnit',
                    expandState: 'isExpand',
                    indicators: 'Indicators',
                    milestone: 'Milestone',
                    notes: 'info',
                    resourceInfo: 'resourceInfo',
                    child: 'subtasks',
                },
            },
        }
        provide: { }
    }});
</script>

taskMode ScheduleMode

Specifies task schedule mode for a project.

Defaults to ‘Auto’

taskType TaskType

taskType Specifies the task type for task whether fixedUnit or fixedWork or fixedDuration.

  • fixedUnit: Sets the task type as fixedUnit.
  • fixedWork: Sets the task type as fixedWork.
  • fixedDuration: Sets the task type as fixedDuration.

Defaults to fixedUnit

taskbarHeight number

Defines height of the taskbar element in the Gantt chart.

Defaults to null

taskbarTemplate string|Function

The task bar template that renders customized child task bars from the given template.
This property allows users to define a custom template for rendering child task bars in the Gantt chart.

    <template>
      <ejs-gantt :taskbarTemplate="'taskbarTemplate'">
      <template v-slot:taskbarTemplate="{data}">
        <div class="e-gantt-child-taskbar-inner-div e-gantt-child-taskbar" style="height:100%">
         <div class="e-gantt-child-progressbar-inner-div e-gantt-child-progressbar" 
          style="width:${ganttProperties.progressWidth}px;height:100%">
           <span class="e-task-label"
                  style="position:absolute;top:5px;font-size:12px;text-overflow:ellipsis;height:90%;overflow:hidden;">
           </span>
         </div>
        </div>
      </template>
        </ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
 
            },
        }
        provide: { }
    }});
</script>

Defaults to null

timelineSettings TimelineSettingsModel

Configures timeline settings of Gantt.
Defines default timeline modes or customized top tier mode and bottom tier mode or single tier only.

    <template>
        <ejs-gantt :timelineSettings="timelineSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                timelineSettings: {
                    showTooltip: true,
                    timelineUnitSize: 80,
                    timelineViewMode: 'Week',
                    updateTimescaleView: true,
                    weekStartDay: 0,
                    weekendBackground: 'red',
                    topTier: {
                        format: 'MMM dd, yyyy',
                        unit: 'Week',
                    },
                    bottomTier: {
                        unit: 'Day',
                        format: 'EEE, dd',
                        count: 1,
                    }
                },
            },
        }
        provide: { }
    }});
</script>

timelineTemplate string|Function

Specifies the template used to render custom HTML content in timeline cells.

<template>
    <ejs-gantt
        :data-source="data"
        :task-fields="taskFields"
        :timeline-template="timelineTemplate"
        height="450px">
    </ejs-gantt>
</template>

<script>
import Vue from "vue";
import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";

Vue.use(GanttPlugin);

export default Vue.extend({
    data: function() {
        return {
            // data, taskFields...
            timelineTemplate: function(props) {
                return `<div style="text-align:center; padding:5px;">${props.value}</div>`;
            }
        };
    }
});
</script>

Defaults to null

timezone string

Specifies the time zone used for task date and scheduling calculations in the Gantt chart.
By default, the system or browser time zone is applied.
The time zone always affects internal date calculations (e.g., task start/end times, durations, and dependencies),
even in non-hour views. However, visible changes in timeline and task positions only appear when the timeline
includes an hour-level mode.

To see the time zone reflected in the UI, configure one of these:

  • timelineViewMode: 'Hour'
  • or topTier.unit: 'Day' + bottomTier.unit: 'Hour'

Without an hour view (e.g., only Day/Week/Month views), the chart looks unchanged, but Gantt chart uses the new time zone.

Use standard IANA time zone names (e.g., ‘Asia/Kolkata’, ‘UTC’, ‘America/New_York’).

Defaults to null

toolbar []

toolbar defines the toolbar items of the Gantt.
It contains built-in and custom toolbar items.
If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the Gantt’s toolbar.


The available built-in toolbar items are:

  • Add: Adds a new record.
  • Edit: Edits the selected task.
  • Update: Updates the edited task.
  • Delete: Deletes the selected task.
  • Cancel: Cancels the edit state.
  • Search: Searches tasks by the given key.
  • ExpandAll: Expands all the task of Gantt.
  • CollapseAll: Collapses all the task of Gantt.
  • PrevTimeSpan: Extends timeline with one unit before the timeline start date.
  • NextTimeSpan: Extends timeline with one unit after the timeline finish date.
  • ZoomIn: ZoomIn the Gantt control.
  • ZoomOut: ZoomOut the Gantt control.
  • ZoomToFit: Display the all tasks within the viewable Gantt chart.
  • ExcelExport: To export in Excel format.
  • CsvExport : To export in CSV format.
  • Indent: To indent a task to one level.
  • Outdent: To outdent a task from one level.

Defaults to null

tooltipSettings TooltipSettingsModel

Enables or disables default tooltip of Gantt element and defines customized tooltip for Gantt elements.

    <template>
        <ejs-gantt :tooltipSettings="tooltipSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                tooltipSettings:{
                    showTooltip: true,
                    taskbar: '<div>TaskID: ${TaskID}</div>',
                    connectorLine: '<div>Offset : ${offsetString}</div>',
                    editing: '<div>Duration : ${duration}</div>',
                    baseline: '<div>Baseline StartDate : ${this.getFormatedDate(BaselineStartDate)}</div>'
                }
            },
        }
        provide: { }
    }});
</script>

Defaults to { showTooltip: true }

treeColumnIndex number

To define expander column index in Grid.

Defaults to 0

undoRedoActions GanttAction[]

undoRedoActions Defines action items that retain for undo and redo operation.

Defaults to [‘Sorting’, ‘Add’, ‘ColumnReorder’, ‘ColumnResize’, ‘ColumnState’, ‘Delete’, ‘Edit’, ‘Filtering’, ‘Indent’, ‘Outdent’, ‘NextTimeSpan’, ‘PreviousTimeSpan’, ‘RowDragAndDrop’, ‘TaskbarDragAndDrop’, ‘Search’, ‘ZoomIn’, ‘ZoomOut’, ‘ZoomToFit’]

undoRedoModule UndoRedo

The undoRedoModule manages the undo and redo functionality in the Gantt chart.

undoRedoStepsCount number

Specifies the number of undo and redo actions to retain in history.

Defaults to 10

updateOffsetOnTaskbarEdit boolean

Specifies whether to update offset value on a task for all the predecessor edit actions.

Defaults to true

validateManualTasksOnLinking boolean

If validateManualTasksOnLinking is set to true,
it enables date validation while connecting manually scheduled tasks with predecessor.

Defaults to false

viewType ViewType

Specifies the view type of the Gantt chart.

Defaults to ‘ProjectView’

virtualScrollModule VirtualScroll

The virtualScrollModule is used to handle virtual scroll in Gantt.

weekWorkingTime WeekWorkingTimeModel[]

Specifies the working days in a week for accurate planning, and works only when the timeline is configured with topTier.unit as ‘Day’ and bottomTier.unit as ‘Hour’ or when timelineViewMode is set to ‘Hour’ or ‘Day’.

width number|string

Defines the width of the Gantt component container.

Defaults to ‘auto’

workUnit WorkUnit

workUnit Specifies the work unit for each tasks whether day or hour or minute.

  • day: Sets the work unit as day.
  • hour: Sets the work unit as hour.
  • minute: Sets the work unit as minute.

Defaults to hour

workWeek string[]

Specifies the project’s workweek (working days).
workWeek specifies the days of the week that are considered working days for the project.

Defaults to [‘Monday’, ‘Tuesday’, ‘Wednesday’, ‘Thursday’, ‘Friday’]

zoomingLevels ZoomTimelineSettings[]

Defines the available zoom levels for the Gantt timeline.
Provide an array of ZoomTimelineSettings to control the scale and intervals used when zooming.

Defaults to []

Methods

addPredecessor

To add dependency for Task.

Parameter Type Description
id number | string Defines the ID of data to modify.
predecessorString string Defines the predecessor string to add.

Returns void

addRecord

Method to add record.

Parameter Type Description
data (optional) Object[] | IGanttData | Object Defines record to add.
rowPosition (optional) RowPosition Defines the position of row.
rowIndex (optional) number Defines the row index.

Returns void

autoFitColumns

Adjusts the width of specified columns to fit their content, preventing wrapping or truncation.
Hidden columns are ignored. For initial rendering, call this method during the dataBound event.

Parameter Type Description
fieldNames (optional) string | string[] The name(s) of the column(s) to auto-fit. Accepts a single column name or an array of column names.

Returns void

cancelEdit

Cancels the current edit operation and reverts the changes made during editing.

Returns void

changeTaskMode

To change the mode of a record.

Parameter Type Description
data Object Use to change the TaskMode either manual, auto or custom.

Returns void

clearFiltering

Clears the filtered columns in Gantt.
Can also be used to clear filtering of a specific column in Gantt.

Parameter Type Description
fields (optional) string[] Defines the specific column to remove filter.

Returns void

clearRedoCollection

Clears the stack collection for redo action.

Returns void

clearSelection

Deselects the current selected rows and cells.

Returns void

clearSorting

Clears all the sorted columns of the Gantt.

Returns void

clearUndoCollection

Clears the stack collection for undo action.

Returns void

collapseAll

Method to collapse all the rows of Gantt.

Returns void

collapseByID

Collapse the record by id value.

Parameter Type Description
id number | string Defines the id of task.

Returns void

collapseByIndex

Collapse the record by index value.

Parameter Type Description
index number Defines the index of row.

Returns void

convertToMilestone

Method to convert task data to milestone data.

Parameter Type Description
id string Defines id of record.

Returns void

csvExport

Export Gantt data to CSV file.

Parameter Type Description
excelExportProperties (optional) ExcelExportProperties Defines the export properties of the Gantt.
isMultipleExport (optional) boolean Define to enable multiple export.
workbook (optional) any Defines the Workbook if multiple export is enabled.
isBlob (optional) boolean If ‘isBlob’ set to true, then it will be returned as blob data.

Returns Promise

deleteRecord

Method to delete record.

Parameter Type Description
taskDetail number | string | number[] | string[] | IGanttData | IGanttData[] Defines the details of data to delete.

Returns void

enableItems

Enables or disables ToolBar items.

Parameter Type Description
items string[] Defines the collection of itemID of ToolBar items.
isEnable boolean Defines the items to be enabled or disabled.

Returns void

excelExport

Export Gantt data to Excel file(.xlsx).

Parameter Type Description
excelExportProperties (optional) ExcelExportProperties Defines the export properties of the Gantt.
isMultipleExport (optional) boolean Define to enable multiple export.
workbook (optional) any Defines the Workbook if multiple export is enabled.
isBlob (optional) boolean If ‘isBlob’ set to true, then it will be returned as blob data.

Returns Promise

expandAll

Method to expand all the rows of Gantt.

Returns void

expandByID

Expand the record by task id.

Parameter Type Description
id number | string Defines the id of task.

Returns void

expandByIndex

Expand the records by index value.

Parameter Type Description
index number[] | number Defines the index of rows to be expand.

Returns void

filterByColumn

Filters TreeGrid row by column name with the given options.

Parameter Type Description
fieldName string Defines the field name of the column.
filterOperator string Defines the operator to filter records.
filterValue string | number | Date | boolean | number[] | string[] | Date[] | boolean[] Defines the value
used to filter records.
predicate (optional) string Defines the relationship between one filter query and another by using AND or OR predicate.
matchCase (optional) boolean If match case is set to true, TreeGrid filters the records with exact match.if false, it filters case
insensitive records (uppercase and lowercase letters treated the same).
ignoreAccent (optional) boolean If ignoreAccent set to true,
then filter ignores the diacritic characters or accents while filtering.

Returns void

fitToProject

To show all project task in available chart width.

Returns void

getCriticalTasks

To get all the critical tasks in Gantt.

Returns IGanttData[]

getCurrentViewData

Retrieves the current view data, reflecting the latest state after filtering, sorting, and CRUD operations.

Returns Object[]

getDurationString

Get duration value as string combined with duration and unit values.

Parameter Type Description
duration number Defines the duration.
durationUnit string Defines the duration unit.

Returns string

getExpandedRecords

Get expanded records from given record collection.

Parameter Type Description
records IGanttData[] Defines record collection.

Returns IGanttData[]

getGanttColumns

Gets the Gantt columns.

Returns ColumnModel[]

getGridColumns

Gets the columns from the TreeGrid.

Returns Column[]

getRecordByID

Method to get record by id value.

Parameter Type Description
id string Defines the id of record.

Returns IGanttData

getRedoActions

To retrieve the collection of actions to reapply.
modifiedRecords - retrieves the modified records.
action - shows the current performed action such as ‘sorting’,’columnReorder’,’columnResize’,’progressResizing’,’rightResizing’,’leftResizing’,’add’,’delete’,’search’,’filtering’,’zoomIn’,’zoomOut’,’zoomToFit’,’columnState’,’previousTimeSpan’,’nextTimeSpan’,’indent’,’outdent’,’rowDragAndDrop’,’taskbarDragAndDrop’,’dialogEdit’

Returns Object[]

getRowByID

Method to get the row element by task id.

Parameter Type Description
id string | number Defines the id of task.

Returns HTMLElement

getRowByIndex

Method to get chart row value by index.

Parameter Type Description
index number Defines the index of row.

Returns HTMLElement

getTaskByUniqueID

Method to get task by uniqueId value.

Parameter Type Description
id string Defines the task id.

Returns IGanttData

getTaskInfo

Retrieves the internal Gantt properties for a task using its Task ID.
This method provides access to task data such as taskbar width, left position, segments collection etc.,.

Parameter Type Description
taskId string The unique identifier of the task.

Returns IGanttTaskInfo

getTaskbarHeight

Method to get taskbarHeight.

Returns number

getUndoActions

To retrieve the collection of previously recorded actions. This method returns an object as a collection that holds the following details.
modifiedRecords - retrieves the modified records.
action - shows the current performed action such as ‘sorting’,’columnReorder’,’columnResize’,’progressResizing’,’rightResizing’,’leftResizing’,’add’,’delete’,’search’,’filtering’,’zoomIn’,’zoomOut’,’zoomToFit’,’columnState’,’previousTimeSpan’,’nextTimeSpan’,’indent’,’outdent’,’rowDragAndDrop’,’taskbarDragAndDrop’,’dialogEdit’

Returns Object[]

getWorkString

Get work value as string combined with work and unit values.

Parameter Type Description
work number Defines the work value.
workUnit string Defines the work unit.

Returns string

hideColumn

Hides one or more columns in the Gantt chart based on the specified column names or header texts.

Parameter Type Description
keys string | string[] Defines a single or collection of column names.
hideBy (optional) string Defines the column key either as field name or header text.

Returns void

hideSpinner

Method used to hide spinner.

Returns void

indent

To indent the level of selected task to the hierarchical Gantt task.

Returns void

mergeTask

Merge the split taskbar with the given segment indexes.

Parameter Type Description
taskId number | string Defines the id of a task to be split.
segmentIndexes Object[] Defines the object array of indexes which must be merged.

Returns void

nextTimeSpan

To update timeline at end point with one unit.

Parameter Type Description
mode (optional) string Render next span of Timeline.

Returns void

openAddDialog

Method to open Add dialog.

Returns void

openEditDialog

Method to open Edit dialog.

Parameter Type Description
taskId (optional) number | string Defines the id of task.

Returns void

outdent

To outdent the level of selected task from the hierarchical Gantt task.

Returns void

pdfExport

Export Gantt data to PDF document.

Parameter Type Description
pdfExportProperties (optional) PdfExportProperties Defines the export properties of the Gantt.
isMultipleExport (optional) boolean Define to enable multiple export.
pdfDoc (optional) Object Defined the Pdf Document if multiple export is enabled.
isBlob (optional) boolean If the ‘isBlob’ parameter is set to true, the method returns PDF data as a blob instead of exporting it as a down-loadable PDF file. The default value is false.

Returns Promise

previousTimeSpan

Updates the Gantt timeline to the previous time span by one unit.

Parameter Type Description
mode (optional) string Render previous span of Timeline.

Returns void

redo

Initiates a redo action to reapply the most recent undone change performed.

Returns void

refreshColumns

Refreshes the column definitions and layout of the TreeGrid pane.
Applies any changes made to column configurations such as visibility, order, or width.
If refreshUI is set to true, the DOM is updated to reflect the latest column settings.

Returns void

removePredecessor

To remove dependency from task.

Parameter Type Description
id number | string Defines the ID of the task from which the dependency will be removed.

Returns void

removeSortColumn

To remove sorted records of particular column.

Parameter Type Description
columnName string Defines the sorted column name.

Returns void

reorderColumns

Changes the TreeGrid column positions by field names.

Parameter Type Description
fromFName string | string[] Defines origin field name.
toFName string Defines destination field name.

Returns void

reorderRows

Reorder the rows based on given indexes and position.

Parameter Type Description
fromIndexes number[] Defines the indexes of the dragged records.
toIndex number Defines the index where the dragged rows will be dropped.
position string Defines the position of the dropped row.

Returns void

scrollToDate

Scrolls the Gantt chart’s timeline horizontally to bring the specified date into view.
This method is useful for navigating directly to a task, milestone, or any specific time range.

Parameter Type Description
date string | Date The target date to scroll to. Accepts a date string or a JavaScript Date object.

Returns void

scrollToTask

To move horizontal scroll bar of Gantt to specific task id.

Parameter Type Description
taskId string Defines the task id of data.

Returns void

Method to perform search action in Gantt.

Parameter Type Description
keyVal string Defines key value to search.

Returns void

selectCell

Selects a cell by the given index.

Parameter Type Description
cellIndex IIndex Defines the row and column indexes.
isToggle (optional) boolean If set to true, then it toggles the selection.

Returns void

selectCells

Selects a collection of cells by row and column indexes.

Parameter Type Description
rowCellIndexes ISelectedCell[] Specifies the row and column indexes.

Returns void

selectRow

Selects a row by given index.

Parameter Type Description
index number Defines the row index.
isToggle (optional) boolean If set to true, then it toggles the selection.

Returns void

selectRows

Selects a collection of rows by indexes.

Parameter Type Description
records number[] Defines the collection of row indexes.

Returns void

setScrollTop

To set scroll top for chart scroll container.

Parameter Type Description
scrollTop number Defines scroll top value for scroll container.

Returns void

setSplitterPosition

Method to set splitter position.

Parameter Type Description
value string | number Define value to splitter settings property.
type string Defines name of internal splitter settings property.

Returns void

showColumn

Shows a column by its column name.

Parameter Type Description
keys string | string[] Defines a single or collection of column names.
showBy (optional) string Defines the column key either as field name or header text.

Returns void

showSpinner

Method used to show spinner.

Returns void

sortColumn

Sorts a column with the given options.

Parameter Type Description
columnName string Defines the column name to be sorted.
direction SortDirection Defines the direction of sorting field.
isMultiSort (optional) boolean Specifies whether the previous sorted columns are to be maintained.

Returns void

splitTask

Splits the taskbar of a specified task into segments based on the given date.

Parameter Type Description
taskId number | string Defines the id of a task to be split.
splitDate Date | Date[] Defines in which date the taskbar must be split up.

Returns void

undo

Initiates an undo action to revert the most recent change performed.

Returns void

updateChartScrollOffset

To update the horizontal (left) and vertical (top) scroll positions of the Gantt chart.

Parameter Type Description
left number Defines the scroll left value of chart side.
top number Defines the scroll top value of chart side.

Returns void

updateDataSource

Method to update data source.

Parameter Type Description
dataSource Object[] Defines a collection of data.
args object Defines the projectStartDate and projectEndDate values.

Returns void

updatePredecessor

To modify current dependency values of Task by task id.

Parameter Type Description
id number | string Defines the ID of data to modify.
predecessorString string Defines the predecessor string to update.

Returns void

updateProjectDates

To validate project start date and end date.

Parameter Type Description
startDate Date Defines start date of project.
endDate Date Defines end date of project.
isTimelineRoundOff boolean Defines project start date and end date need to be round off or not.
isFrom (optional) string Defines whether the call originates from a public method action or a taskbar editing action.

Returns void

updateRecordByID

Method to update record by ID.

Parameter Type Description
data Object Defines the data to modify.

Returns void

updateRecordByIndex

Method to update record by Index.

Parameter Type Description
index number Defines the index of data to modify.
data Object Defines the data to modify.

Returns void

updateTaskId

To update existing taskId with new unique Id.

Parameter Type Description
currentId number | string Defines the current Id of the record.
newId number | string Defines the new Id of the record.

Returns void

zoomIn

To perform Zoom in action on Gantt timeline.

Returns void

zoomOut

To perform zoom out action on Gantt timeline.

Returns void

Events

actionBegin EmitType<Object|FilterEventArgs|SortEventArgs|ITimeSpanEventArgs|IDependencyEventArgs|ITaskAddedEventArgs|ZoomEventArgs>

Event triggered when a Gantt action (sorting, filtering, searching, etc.) begins.
Allows cancellation or modification of the action.

actionComplete EmitType<FilterEventArgs|SortEventArgs|ITaskAddedEventArgs|IKeyPressedEventArgs|ZoomEventArgs>

Event triggered after a Gantt action (sorting, filtering, etc.) has completed.
Provides updated state after the action.

actionFailure EmitType<FailureEventArgs>

Event triggered when a Gantt action fails during execution.
Provides error details.

beforeDataBound EmitType<BeforeDataBoundArgs>

Event triggered before data is bound to the TreeGrid.
Allows modification of data before rendering begins.

beforeExcelExport EmitType<Object>

Event triggered before Gantt data is exported to Excel.
Allows modification or cancellation of the export process.

beforePdfExport EmitType<Object>

Event triggered before Gantt data is exported to PDF.
Allows modification or cancellation of PDF export.

beforeTooltipRender EmitType<BeforeTooltipRenderEventArgs>

Event triggered before a tooltip is rendered.
Allows customization of tooltip content or cancellation.

cellDeselected EmitType<CellDeselectEventArgs>

Event triggered after a cell has been deselected.

cellDeselecting EmitType<CellDeselectEventArgs>

Event triggered before a selected cell is deselected.
Allows cancellation of cell deselection.

cellEdit EmitType<CellEditArgs>

Event triggered when a cell enters edit mode in the Gantt chart.
Allows customization or cancellation of editing.

cellSave EmitType<CellSaveArgs>

Event triggered before a cell value is saved during editing.
Allows cancellation or modification of the save operation.

cellSelected EmitType<CellSelectEventArgs>

Event triggered after a cell has been selected.

cellSelecting EmitType<CellSelectingEventArgs>

Event triggered before a cell is selected.
Allows cancellation of cell selection.

collapsed EmitType<ICollapsingEventArgs>

Event triggered after a row has been collapsed.
Indicates the collapse action has completed.

collapsing EmitType<ICollapsingEventArgs>

Event triggered before a row is collapsed.
Allows cancellation of the collapse action.

columnDrag EmitType<ColumnDragEventArgs>

Event triggered continuously while a column header is being dragged.

columnDragStart EmitType<ColumnDragEventArgs>

Event triggered when column header drag starts.

columnDrop EmitType<ColumnDragEventArgs>

Event triggered when a dragged column header is dropped.

columnMenuClick EmitType<ColumnMenuClickEventArgs>

Event triggered when an item in the column menu is clicked.

columnMenuOpen EmitType<ColumnMenuOpenEventArgs>

Event triggered before the column menu is opened.
Allows customization or cancellation of menu display.

contextMenuClick EmitType<CMenuClickEventArgs>

Event triggered when an item in the context menu is clicked.

contextMenuOpen EmitType<CMenuOpenEventArgs>

Event triggered before the context menu is opened.
Allows customization or cancellation.

created EmitType<Object>

Event triggered after the Gantt component is fully created and initialized.

dataBound EmitType<Object>

Event triggered after the data source is bound to the TreeGrid part of Gantt.
Indicates data binding is complete.

dataSourceChanged EmitType<DataSourceChangedEventArgs>

Triggers when data in the Gantt is added, deleted, or updated.
Invoke the done method from the argument to start rendering after an edit operation.

dataStateChange EmitType<DataStateChangeEventArgs>

Event triggered after actions like sorting, filtering complete.
Used to update the dataSource with current view data and record count.

destroyed EmitType<Object>

Event triggered when the Gantt component is being destroyed.
Allows cleanup operations.

endEdit EmitType<ITaskbarEditedEventArgs>

Event triggered when a task is saved through cell editing.
Provides updated task data after save.

excelExportComplete EmitType<ExcelExportCompleteArgs>

Event triggered after Gantt data has been successfully exported to Excel.
Provides access to the generated workbook.

excelHeaderQueryCellInfo EmitType<ExcelHeaderQueryCellInfoEventArgs>

Event triggered before each header cell is exported to Excel.
Allows customization of header cell content or styling.

excelQueryCellInfo EmitType<ExcelQueryCellInfoEventArgs>

Event triggered before each cell (header or data) is exported to Excel.
Allows customization of cell content, style, or value.

expanded EmitType<ICollapsingEventArgs>

Event triggered after a row has been expanded.
Indicates the expand action has completed.

expanding EmitType<ICollapsingEventArgs>

Event triggered before a row is expanded.
Allows cancellation of the expand action.

headerCellInfo EmitType<HeaderCellInfoEventArgs>

Event triggered before each header cell element is rendered.
Allows customization of header cell content or style.

load EmitType<Object>

Event triggered when the Gantt component begins loading data.
Occurs before any rendering starts.

onMouseMove EmitType<IMouseMoveEventArgs>

Event triggered on mouse move over the Gantt component.
Provides mouse position and target information.

onTaskbarClick EmitType<ITaskbarClickEventArgs>

Event triggered when a taskbar element is clicked.
Provides task and click details.

pdfColumnHeaderQueryCellInfo EmitType<PdfColumnHeaderQueryCellInfoEventArgs>

Event triggered before each column header cell is exported to PDF.
Allows customization of header cell content or style.

pdfExportComplete EmitType<Object>

Event triggered after Gantt data has been exported to PDF.
Provides access to the generated document.

pdfQueryCellInfo EmitType<PdfQueryCellInfoEventArgs>

Event triggered before each cell is exported to PDF.
Allows customization of cell content or style.

pdfQueryTaskbarInfo EmitType<Object>

Event triggered before each taskbar is exported to PDF.
Allows customization of taskbar appearance in PDF.

pdfQueryTimelineCellInfo EmitType<PdfQueryTimelineCellInfoEventArgs>

Event triggered before each timeline cell is exported to PDF.
Allows customization of timeline cell content or style.

queryCellInfo EmitType<QueryCellInfoEventArgs>

Event triggered before each cell element is rendered.
Allows customization of cell content or style.

queryTaskbarInfo EmitType<IQueryTaskbarInfoEventArgs>

Event triggered per taskbar before rendering in the Gantt chart.
Used to customize taskbar styles and properties dynamically.

recordDoubleClick EmitType<RecordDoubleClickEventArgs>

Event triggered when a record is double-clicked.

resizeStart EmitType<ResizeArgs>

Event triggered when column resizing starts in the Grid.

resizeStop EmitType<ResizeArgs>

Event triggered when column resizing completes.

resizing EmitType<ResizeArgs>

Event triggered continuously while a column is being resized.

rowDataBound EmitType<RowDataBoundEventArgs>

Event triggered before each row element is rendered.
Allows customization of row appearance.

rowDeselected EmitType<RowDeselectEventArgs>

Event triggered after a row has been deselected.

rowDeselecting EmitType<RowDeselectEventArgs>

Event triggered before a selected row is deselected.
Allows cancellation of deselection.

rowDrag EmitType<RowDragEventArgs>

Event triggered continuously while row elements are being dragged.
Provides current drag position and target information.

rowDragStart EmitType<RowDragEventArgs>

Event triggered when a row drag operation starts.
Provides initial drag source details.

rowDragStartHelper EmitType<RowDragEventArgs>

Event triggered before the row drag operation officially begins.
Allows preparation or cancellation of the drag action.

rowDrop EmitType<RowDragEventArgs>

Event triggered when dragged row elements are dropped onto a target row.
Provides source and target row information for reordering/indent/outdent.

rowSelected EmitType<RowSelectEventArgs>

Event triggered after a row has been selected.

rowSelecting EmitType<RowSelectingEventArgs>

Event triggered before a row is selected.
Allows cancellation of selection.

splitterResizeStart EmitType<ResizeEventArgs>

Event triggered when splitter resizing begins in the Gantt component.

splitterResized EmitType<ISplitterResizedEventArgs>

Event triggered when splitter resizing action completes.

splitterResizing EmitType<ResizingEventArgs>

Event triggered continuously while the splitter bar is being dragged.

taskbarEdited EmitType<ITaskbarEditedEventArgs>

Event triggered after a taskbar has been dragged and dropped to a new position.
Indicates editing via taskbar has completed.

taskbarEditing EmitType<ITaskbarEditedEventArgs>

Event triggered while a taskbar is being dragged.
Provides current drag progress and position.

toolbarClick EmitType<ClickEventArgs>

Event triggered when a toolbar item is clicked.

GanttComponent
9 Jul 202624 minutes to read
ejs-gantt represents the Angular Gantt Component.
<ejs-gantt [dataSource]='data' allowSelection='true' allowSorting='true'></ejs-gantt>Properties
addDialogFields AddDialogFieldSettingsModel[]
Defines the tabs and fields to be displayed in the add dialog.
If not specified, the fields will be derived from the taskSettings and columns values.
<ejs-gantt [addDialogFields]="addDialogFields"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public addDialogFields: object[];
public ngOnInit(): void {
this.addDialogFields = [
{ type: 'General', headerText: 'General', fields: ['TaskID', 'TaskName'] },
{ type: 'Resources' },
{ type: 'Dependency' },
{ type: 'Notes'}
];
}
}Defaults to []
allowExcelExport boolean
Enables exporting the Gantt chart to Excel (.xlsx) and CSV formats.
When set to true, users can export the chart data.
Defaults to false
allowFiltering boolean
Enables or disables filtering functionality in the Gantt chart.
Defaults to false
allowKeyboard boolean
Enables or disables keyboard interactions in the Gantt chart.
Defaults to true
allowParentDependency boolean
Specifies whether dependency connections are supported for parent tasks.
Only allows dependencies between tasks belonging to different parents.
Dependencies within the same parent are not supported.
Defaults to true
allowPdfExport boolean
If allowPdfExport set to true, then it will allow the user to export Gantt chart to PDF file.
Defaults to false
allowReordering boolean
If allowReordering is set to true, Gantt chart columns can be reordered.
Reordering can be done by drag and drop of a particular column from one index to another index.
Defaults to false
allowResizing boolean
Enables column resizing in the Gantt chart when allowResizing is set to true.
When enabled, users can adjust the width of columns by dragging the column borders.
Defaults to false
allowRowDragAndDrop boolean
If allowRowDragAndDrop set to true, then it will allow the user to perform row drag and drop action in Gantt chart.
Defaults to false
allowSelection boolean
Specifies whether to enable row selection in the Gantt chart. When enabled, selected rows are highlighted.
Defaults to true
allowSorting boolean
If allowSorting is set to true, it enables sorting of Gantt chart tasks when the column header is clicked.
Defaults to false
allowTaskbarDragAndDrop boolean
Specifies whether taskbar drag and drop is enabled in the Gantt chart.
Defaults to false
allowTaskbarOverlap boolean
Specifies whether taskbars can overlap in the Gantt chart. To enable overlapping behavior, use this property along with enableMultiTaskbar.
Defaults to true
allowUnscheduledTasks boolean
Enables or disables the rendering of unscheduled tasks in the Gantt chart.
When allowUnscheduledTasks set to true, unscheduled tasks will be displayed in the chart.
Defaults to false
autoCalculateDateScheduling boolean
Specifies whether to auto calculate the start and end dates based on factors such as working time, holidays, weekends, and task dependencies.
Defaults to true
autoFocusTasks boolean
Specifies whether to automatically scroll the corresponding taskbar into view when a task is selected.
Defaults to true
autoUpdatePredecessorOffset boolean
Determines whether to automatically validate and update predecessor offsets in the IPredecessor collection and columns during initial load.
When true, ensures data consistency with rendering validations.
Defaults to false
baselineColor string
Specifies the color of the baseline bar in the Gantt chart.
import { Component, ViewEncapsulation, OnInit,IGanttData } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
template:
`<ejs-gantt id="ganttDefault" height="430px" [dataSource]="data" [renderBaseline]="true" baselineColor='red'></ejs-gantt>`,
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public ngOnInit(): void {
}
}Defaults to null
baselineTemplate any
.
Accepts an element ID selector, HTML string, or function returning string or HTMLElement.
Defines a custom template for rendering baseline bars in the Gantt chart.
Defaults to null
calendarSettings CalendarSettingsModel
Defines the calendar configuration for the project, including working times, holidays, and task-specific calendars.
This setting enables customization of scheduling behavior across the Gantt chart, including:
- Global working hours and non-working days
- Holiday definitions with localized labels
- Task-level calendar overrides via
taskFields.calendarId
Defaults to {}
collapseAllParentTasks boolean
Defines whether all root tasks should be rendered in a collapsed state. When collapseAllParentTasks set to true, all parent tasks will be collapsed by default.
Defaults to false
columnMenuItems []
columnMenuItems defines both built-in and custom menu items for the Gantt chart column menu.
The available built-in items are,
-
ColumnChooser- To show/hide the TreeGrid columns. -
SortAscending- Sort the current column in ascending order. -
SortDescending- Sort the current column in descending order. -
AutoFitAll- Auto fit the size of all columns. -
AutoFit- Auto fit the size of the current column. -
Filter- Displays filter options based on thefilterSettingsproperty.
Defaults to null
columnMenuModule ColumnMenu
The columnMenuModule is used to manage and customize the column menu in the Gantt chart.
columns Column[]|string[]|ColumnModel[]
Defines the collection of columns displayed in the Gantt chart grid.
If the columns declaration is empty, the columns are automatically populated based on the taskSettings values.
<ejs-gantt [columns]="columns"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public columns: object[];
public ngOnInit(): void {
this.columns = [
{ field: 'TaskID', width: '150', headerText: 'Task ID', headerTextAlign: 'Left' allowFiltering: false },
{ field: 'TaskName', clipMode: 'EllipsisWithTooltip' allowEditing: true, hideAtMedia: '(min-width: 700px)' },
{ field: 'Duration', edittype: 'stringedit', allowReordering: true, maxWidth: '400' },
{ field: 'Progress', textAlign: 'Right', allowResizing: false , visible: true, format: 'C' },
{ field: 'StartDate', width: '250', allowSorting: false, minWidth: '200' }
];
}
}Defaults to []
connectorLineBackground string
Specifies the background color of dependency (connector) lines in the Gantt chart.
Accepts any valid CSS color value (for example: “red”, “#FF5733”, “rgb(255, 0, 0)”).
Defaults to null
connectorLineWidth number
Defines the width of the dependency lines in the Gantt chart.
The value should be a positive integer, representing the thickness of the lines.
Defaults to 1
contextMenuItems ContextMenuItem[]|ContextMenuItemModel[]
Defines the built-in and custom items that appear in the context menu of the Gantt chart.
You can use this property to control the content and functionality of the right-click context menu.
<ejs-gantt [contextMenuItems]="contextMenuItems"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
import { ContextMenuItemModel } from '@syncfusion/ej2-grids';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public contextMenuItems: (string | ContextMenuItemModel)[];
public ngOnInit(): void {
this.contextMenuItems = ['AutoFitAll', 'AutoFit', 'TaskInformation', 'DeleteTask', 'Save', 'Cancel', 'SortAscending', 'SortDescending', 'Add', 'DeleteDependency', 'Convert',
{ text: 'Collapse the Row', target: '.e-content', id: 'collapserow' } as ContextMenuItemModel,
{ text: 'Expand the Row', target: '.e-content', id: 'expandrow' } as ContextMenuItemModel,
];
}
}Defaults to null
contextMenuModule ContextMenu
The contextMenuModule is responsible for managing and invoking the context menu in the Gantt chart.
It provides the functionality to display and interact with the context menu, which can be customized using the contextMenuItems property.
criticalPathModule CriticalPath
The criticalPathModule is used to determine the critical path in the Gantt chart.
It identifies the sequence of tasks that directly affect the project’s duration and highlights them.
currentZoomingLevel ZoomTimelineSettings
Specifies the current zooming level of the Gantt chart.
dataSource Object[]|DataManager|Object
Defines the data source for the Gantt chart, which is used to render rows and tasks.
The dataSource can be an array of JavaScript objects, an instance of DataManager, or a single object.
The array of objects should contain the task data with properties such as TaskID, TaskName, StartDate, EndDate, etc.
This allows dynamic binding of tasks and their relationships (e.g., dependencies, subtasks, progress) to the Gantt chart.
<ejs-gantt [dataSource]="data"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public data: object[];
public ngOnInit(): void {
// Hierarchical data binding.
this.data = [
{
TaskID: 1,
TaskName: 'Project Initiation',
StartDate: new Date('04/02/2019'),
EndDate: new Date('04/21/2019'),
subtasks: [
{ TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
{ TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
]
},
];
// Self-referential data binding (Flat data).
this.data = [
{ TaskID: 1,TaskName: 'Project Initiation',StartDate: new Date('04/02/2019'),EndDate: new Date('04/21/2019')},
{ TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50,ParentId:1 },
{ TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50, ParentId:1 },
];
//Remote data
this.data = new DataManager({
url: 'https://ej2services.syncfusion.com/production/web-services/api/GanttData',
adaptor: new WebApiAdaptor,
crossDomain: true
});
}
}Defaults to []
dateFormat string
Specifies the date format for displaying dates in the Gantt chart, including in tooltips and grid cells.
By default, the format is determined based on the current culture/locale settings.
dayMarkersModule DayMarkers
The dayMarkersModule is used to manage and manipulate event markers in the Gantt chart.
It allows customization of how markers are displayed on specific days, helping to highlight important dates or milestones.
dayWorkingTime DayWorkingTimeModel[]
Defines the customized working time for the project to ensure accurate task scheduling, and works only when the timeline is configured with topTier.unit as ‘Day’ and bottomTier.unit as ‘Hour’ or when timelineViewMode is set to ‘Hour’ or ‘Day’.
<ejs-gantt [dayWorkingTime]="dayWorkingTime"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
piblic dayWokringTime: object[];
public ngOnInit(): void {
this.dayWorkingTime = [{ from: 9, to: 18}];
}
}disableHtmlEncode boolean
If disableHtmlEncode is set to true, the Gantt component disables HTML entity encoding across the Gantt content, allowing custom HTML elements to be rendered.
Defaults to true
durationUnit DurationUnit
durationUnit Specifies the duration unit for each task. The available options are:
-
day: Sets the duration unit to day. -
hour: Sets the duration unit to hour. -
minute: Sets the duration unit to minute.
Defaults to day
editDialogFields EditDialogFieldSettingsModel[]
Defines the tabs and fields to be displayed in the edit dialog.
If not specified, the fields will be derived from the taskSettings and columns values.
<ejs-gantt [editDialogFields]="editDialogFields"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public editDialogFields: object[];
public ngOnInit(): void {
this.editDialogFields = [
{ type: 'General', headerText: 'General', fields: ['TaskID', 'TaskName'] },
{ type: 'Resources' },
{ type: 'Dependency' },
{ type: 'Notes'}
];
}
}Defaults to []
editModule Edit
The editModule handles the manipulation of Gantt chart records, including editing, updating, and deleting tasks.
editSettings EditSettingsModel
Configures the edit settings for the Gantt chart, such as enabling or disabling task modifications.
<ejs-gantt [editSettings]="editSettings"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
import { EditSettingsModel } from '@syncfusion/ej2-angular-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public editSettings: EditSettingsModel;
public ngOnInit(): void {
this.editSettings = {
allowAdding: true,
allowEditing: true,
allowDeleting: true,
allowTaskbarEditing: true,
mode:'Auto',
newRowPosition: 'Top',
showDeleteConfirmDialog: true
};
}
}Defaults to { allowAdding: false, allowEditing: false, allowDeleting: false, mode:’Auto’,showDeleteConfirmDialog: false }
emptyRecordTemplate any
Defines a custom template to display when the Gantt chart has no records.
This template replaces the default empty record message and can include text, HTML elements, or images.
Accepts either a template string or an HTML element ID.
Defaults to null
enableAdaptiveUI boolean
Specifies whether to enable an adaptive UI mode, which optimizes the layout of pop-ups for filtering, editing, and other features on smaller screens, such as mobile devices. *
Defaults to false
enableAutoWbsUpdate boolean
Enables the automatic update of WBS codes when performing actions like sorting, filtering, row drag and drop, and other grid operations that change the task order or hierarchy.
When set to true, the Gantt component will refresh and regenerate the WBS codes dynamically after such actions to ensure the codes remain in sync with the current task structure.
Defaults to false
enableContextMenu boolean
If enableContextMenu is set to true, enables the context menu in the Gantt chart.
The context menu provides additional actions that can be accessed by right-clicking on Gantt chart elements
Defaults to false
enableCriticalPath boolean
Enables the highlighting of critical tasks in the Gantt Chart that directly affect the project’s end date.
When enabled, tasks that are critical to the project timeline will be visually distinguished by colours.
Defaults to false
enableHover boolean
If enableHover is set to true, it enables hover in the Gantt chart and highlights the rows, chart rows, header cells and timeline cells.
Defaults to false
enableHtmlSanitizer boolean
Specifies whether to display or remove the untrusted HTML values in the TreeGrid component.
If enableHtmlSanitizer set to true, any potentially harmful strings and scripts are sanitized before rendering.
Defaults to true
enableImmutableMode boolean
If enableImmutableMode is set to true, the Gantt Chart will reuse existing rows from previous results instead of
performing a full refresh when Gantt actions are executed.
Defaults to false
enableInfiniteTimelineScroll boolean
Enables infinite horizontal scrolling for the Gantt timeline by dynamically
extending the timeline when the scroll reaches the end.
Defaults to false
enableMultiTaskbar boolean
Enables the rendering of child taskbars on the parent row when it is in a collapsed state in the Gantt chart.
Defaults to false
enablePersistence boolean
Enable or disable persisting component’s state between page reloads.
Defaults to false
enablePredecessorValidation boolean
If enablePredecessorValidation is set to true, enables validation for predecessor links in the Gantt chart.
Defaults to true
enableRtl boolean
Enable or disable rendering component in right to left direction.
Defaults to false
enableTimelineVirtualization boolean
Enables better performance for projects with a large time span by initially rendering only the visible timeline cells when enableVirtualization is enabled.
Subsequent cells are loaded on horizontal scrolling.
Defaults to false
enableUndoRedo boolean
enableUndoRedo enables or disables the undo/redo functionality in the Gantt chart.
Enables undo and redo in the Gantt chart. When set to true, users can
revert or reapply recent changes.
Defaults to false
enableVirtualMaskRow boolean
Specifies whether to display a shimmer effect during scrolling in the virtual scrolling feature when enableVirtualization is enabled. If disabled, a spinner is shown instead of the shimmer effect.
Defaults to true
enableVirtualization boolean
If enableVirtualization is set to true, the Gantt chart will render only the rows visible within the viewport.
and load subsequent rows as the user scrolls vertically. This improves performance when dealing with large datasets.
Defaults to false
enableWBS boolean
Enables Work Breakdown Structure (WBS) functionality in the Gantt Chart.
When set to true, the Gantt Chart automatically generates WBS codes based on the task hierarchy.
A dedicated WBS Code column will be shown to represent the task structure.
Additionally, if task dependencies (predecessors) are mapped in the data source, a WBS Predecessor column will also be displayed to reflect dependency information using WBS codes.
Defaults to false
eventMarkers EventMarkerModel[]
Defines the events and milestones along the project timeline.
These event markers indicate significant events or milestones throughout the project’s duration.
<ejs-gantt [eventMarkers]="eventMarkers"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public eventMarkers : object[];
public ngOnInit(): void {
this.eventMarkers = [
{
day: new Date('04/10/2019'),
label: 'Project approval and kick-off',
cssClass: 'e-custom-event-marker',
}
];
}
}Defaults to []
excelExportModule ExcelExport
The excelExportModule is used for exporting Gantt data to an Excel file.
This module provides the functionality to export task data, dependencies, and other Gantt-related information in Excel format.
filterModule Filter
The filterModule is used to manage and apply filtering operations in the Gantt chart.
filterSettings FilterSettingsModel
Configures the filter settings for the Gantt chart, enabling users to filter tasks based on specific columns or criteria.
The filterSettings property allows customization of filter behavior, such as which columns to filter and the filter type.
<ejs-gantt [filterSettings]="filterSettings"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public filterSettings: object;
public ngOnInit(): void {
this.filterSettings = {
columns: [{ field: 'TaskName', matchCase: false, operator: 'startswith', predicate: 'and', value: 'Identify' },{ field: 'TaskID', matchCase: false, operator: 'equal', predicate: 'and', value: 2 }],
ignoreAccent: true
};
}
}Defaults to {columns: [], type: ‘Menu’ }
frozenColumns number
Specifies the number of columns that should remain visible and fixed on the left side of the Gantt during horizontal scrolling.
This feature ensures key columns, such as identifiers, stay visible while users scroll through data.
Defaults to 0
gridLines GridLine
Configures the grid lines displayed in the TreeGrid and Gantt chart.
The gridLines property allows customization of the type of grid lines to be shown, either horizontal, vertical, both or none.
-
Both: Displays both horizontal and vertical grid lines. -
None: Hides both horizontal and vertical grid lines. -
Horizontal: Displays only horizontal grid lines. -
Vertical: Displays only vertical grid lines. -
Default: Adjusts line visibility based on the theme.
Defaults to ‘Horizontal’
height number|string
Defines the height of the Gantt component container.
The height property can be set to a specific value (in pixels or percentage) or set to ‘auto’ for automatic height adjustment based on content.
Defaults to ‘auto’
highlightWeekends boolean
If highlightWeekends is set to true, it highlights all weekend days in the week-day timeline mode.
This makes weekends visually distinct in the timeline view.
Defaults to false
holidays HolidayModel[]
Defines holidays within the project timeline, allowing you to mark specific dates as holidays.
This helps in accounting for non-working days in scheduling and task planning.
<ejs-gantt [holidays] = "holidays"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public holidays: object[];
public ngOnInit(): void {
this.holidays = [{
from: "04/04/2019",
to:"04/05/2019",
label: " Public holidays",
cssClass:"e-custom-holiday"
}];
}
}Defaults to []
includeWeekend boolean
Specifies whether weekend days are considered working days in the Gantt chart.
When includeWeekend is set to true, weekends (Saturday and Sunday) are treated as regular working days.
Defaults to false
keyboardModule KeyboardEvents
The keyboardModule is responsible for managing keyboard interactions in the Gantt chart.
It handles events such as navigating, selecting, and performing actions using the keyboard.
labelSettings LabelSettingsModel
Configures the labels displayed on the right, left, and inside the taskbars in the Gantt chart.
<ejs-gantt [labelSettings]="labelSettings"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public labelSettings: object;
public ngOnInit(): void {
this.labelSettings = {
leftLabel: 'Task ID: ${taskData.TaskID}',
rightLabel:'Progress Value: ${taskData.Progress}',
taskLabel: '${Progress}%'
}
}
}loadChildOnDemand boolean
Gets or sets whether to load child records on demand in remote data binding. When loadChildOnDemand set to true, child records are loaded only when expanded, and parent records are rendered in a collapsed state initially.
Defaults to true
loadingIndicator LoadingIndicatorModel
Specifies the type of loading indicator to display during scrolling action in the virtual scrolling feature when enableVirtualization is enabled.
Defaults to {indicatorType: ‘Spinner’}
locale string
Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.
Defaults to ’’
milestoneTemplate any
Defines a custom template for rendering milestone tasks in the Gantt chart. This template allows you to customize the appearance of milestone tasks.
Defaults to null
parentTaskbarTemplate any
Defines a custom template for rendering parent task bars in the Gantt chart. This template allows you to customize the appearance of parent task bars.
<ejs-gantt id="ganttDefault">
<ng-template #parentTaskbarTemplate let-data>
<div
class="e-gantt-parent-taskbar-inner-div e-gantt-parent-taskbar"
[style.width.px]="data.ganttProperties.width"
style="height:22px;margin-top:-1px;"
tabindex="-1"
>
<div
class="e-gantt-parent-progressbar-inner-div e-gantt-parent-progressbar"
style="border-style:solid;border-top-right-radius:0px;border-bottom-right-radius:0px;height:100%;"
[style.width.px]="calculateProgressWidth(data)"
>
<span
class="e-task-label"
style="line-height:21px; text-align:left;display:inline-block;width:122px; height:22px;"
>{{ data.TaskName }}</span
>
</div>
</div>
</ng-template>
</ejs-gantt>import { Component, ViewEncapsulation, OnInit,IGanttData } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public calculateProgressWidth(data:IGanttData) {
// Calculate the progress width based on the taskbar width and progress value
return (data.ganttProperties.progress * data.ganttProperties.width) / 100;
}
public ngOnInit(): void {
}
}Defaults to null
pdfExportModule PdfExport
The pdfExportModule is used for exporting the Gantt chart data to a PDF format.
This module provides functionality for exporting the entire chart or specific data to a PDF document.
projectEndDate Date|string
Defines the end date of the project. If the projectEndDate is not set, it will be automatically calculated based on the data source.
The date can be provided as a Date object or a string in a valid date format.
Defaults to null
projectStartDate Date|string
Defines the start date of the project. If the projectStartDate is not set, it will be automatically calculated based on the data source.
The date can be provided as a Date object or a string in a valid date format.
Defaults to null
query Query
Defines an external Query
that will be executed in conjunction with data processing to filter, sort the data.
This allows for advanced data manipulation before binding the data to the Gantt chart.
import { Component, ViewEncapsulation } from '@angular/core';
import { DataManager, Query, WebApiAdaptor } from '@syncfusion/ej2-data';
@Component({
selector: 'app-root',
template: `
<ejs-gantt
id="Gantt"
height="450px"
[dataSource]="dataSource"
[query]="customQuery"
[taskFields]="taskFields"
[labelSettings]="labelSettings">
</ejs-gantt>
`,
encapsulation: ViewEncapsulation.None
})
export class AppComponent {
public dataSource: DataManager = new DataManager({
url: 'https://ej2services.syncfusion.com/production/web-services/api/GanttData',
adaptor: new WebApiAdaptor(),
crossDomain: true
});
// Create query with custom parameter (common pattern to signal "Gantt mode" to server)
public customQuery: Query = new Query()
.addParams('ej2Gantt', 'test');
public taskFields = {
id: 'TaskID',
name: 'TaskName',
startDate: 'StartDate',
endDate: 'EndDate',
duration: 'Duration',
progress: 'Progress',
parentID: 'ParentID'
};
public labelSettings = { leftLabel: 'TaskName' };
}Defaults to null
readOnly boolean
If readOnly is set to true, the Gantt chart becomes read-only, meaning tasks and other elements cannot be edited.
This setting disables all editing features, including task updates, dependency management, and any editing acions.
Defaults to false
renderBaseline boolean
If renderBaseline is set to true, baselines will be rendered for tasks in the Gantt chart.
Baselines provide a visual reference to track the planned vs. actual progress of tasks.
Defaults to false
resourceFields ResourceFieldsModel
Defines the mapping properties to extract resource values, such as id, name, unit, and group from the resource collection in the Gantt chart.
This helps to map data from a custom resource collection to the appropriate fields for resource allocation.
resourceIDMapping string
Defines the mapping property to retrieve the resource ID value from the resource collection.
This is used to map the resource ID from the resource data to the Gantt chart for resource allocation.
import { Component } from '@angular/core';
@Component({
selector: 'app-root',
template: `<ejs-gantt
[dataSource]="data"
[taskFields]="taskFields"
[resourceFields]="resourceFields"
[resources]="resources"
[labelSettings]="labelSettings">
</ejs-gantt>`
})
export class AppComponent {
data = [
{ TaskID: 1, TaskName: 'Task 1', StartDate: new Date('2025-01-01'), Duration: 5, resources: [1] },
{ TaskID: 2, TaskName: 'Task 2', StartDate: new Date('2025-01-03'), Duration: 4, resources: [1, 2] }
];
resources = [
{ resourceId: 1, resourceName: 'Martin' },
{ resourceId: 2, resourceName: 'Rose' }
];
taskFields = { resourceInfo: 'resources' };
resourceFields = {
id: 'resourceId', // Maps resource ID field → conceptually resourceIDMapping
name: 'resourceName' // Maps resource Name field → conceptually resourceNameMapping
};
labelSettings = { rightLabel: 'resources' };
}Defaults to null
resourceNameMapping string
Defines the mapping property to retrieve the resource name value from the resource collection.
This is used to map the resource name from the resource data to the Gantt chart for task allocation.
import { Component } from '@angular/core';
@Component({
selector: 'app-root',
template: `<ejs-gantt
[dataSource]="data"
[taskFields]="taskFields"
[resourceFields]="resourceFields"
[resources]="resources"
[labelSettings]="labelSettings">
</ejs-gantt>`
})
export class AppComponent {
data = [
{ TaskID: 1, TaskName: 'Task 1', StartDate: new Date('2025-01-01'), Duration: 5, resources: [1] },
{ TaskID: 2, TaskName: 'Task 2', StartDate: new Date('2025-01-03'), Duration: 4, resources: [1, 2] }
];
resources = [
{ resourceId: 1, resourceName: 'Martin' },
{ resourceId: 2, resourceName: 'Rose' }
];
taskFields = { resourceInfo: 'resources' };
resourceFields = {
id: 'resourceId', // Maps resource ID field → conceptually resourceIDMapping
name: 'resourceName' // Maps resource Name field → conceptually resourceNameMapping
};
labelSettings = { rightLabel: 'resources' };
}Defaults to null
resources object[]
Specifies the collection of resources assigned to the project.
Defaults to []
rowDragAndDropModule RowDD
The rowDragAndDropModule manages the row reordering functionality in the Gantt chart.
It allows users to drag and drop rows to reorder tasks within the Gantt chart view.
rowHeight number
Defines the height of grid and chart rows in the Gantt chart.
This property sets the vertical space allocated for each task or row, allowing customization of row sizes.
Defaults to 36
searchSettings SearchSettingsModel
Configures the search functionality within the Gantt chart.
<ejs-gantt [searchSettings]="searchSettings"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
import { SearchSettingsModel } from '@syncfusion/ej2-angular-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public searchSettings: SearchSettingsModel;
public ngOnInit(): void {
this.searchSettings = { fields: ['TaskName'], operator: 'contains', key: 'product', ignoreCase: true hierarchyMode: 'Parent'}
}
}segmentData object[]
Specifies the array of segment objects assigned to tasks in the Gantt chart.
Each segment represents a portion of the taskbar, allowing for visual representation of different phases or sub-tasks within a single task.
Defaults to []
selectedRowIndex number
The selectedRowIndex allows you to specify the index of the row to be selected at the time of initial rendering.
It can also be used to get the currently selected row index after selection.
A value of -1 indicates no row is selected.
Defaults to -1
selectionModule Selection
The selectionModule is used to manipulate selection operation in the Gantt chart.
selectionSettings SelectionSettingsModel
Configures the settings for selection in the Gantt chart.
<ejs-gantt [selectionSettings]="selectionSettings"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
import { SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public selectionSettings: SelectionSettingsModel;
public ngOnInit(): void {
this.selectionSettings = {
mode: 'Row',
type: 'Multiple'
};
}
}Defaults to {mode: ‘Row’, type: ‘Single’}
showColumnMenu boolean
If showColumnMenu set to true, enables the column menu options for each column header in the Gantt chart.
Defaults to false
showInlineNotes boolean
To show notes column cell values inside the cell or in tooltip.
Defaults to false
showOverAllocation boolean
If showOverAllocation set to true, enables the rendering of the overallocation container in the Gantt chart.
Defaults to false
sortModule Sort
The sortModule is used to manipulate sorting operation in Gantt.
sortSettings SortSettingsModel
Configures the sorting options for the Gantt chart.
When set, it defines how tasks are sorted based on the specified columns.
<ejs-gantt [sortSettings]="sortSettings"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public sortSettings: object;
public ngOnInit(): void {
this.sortSettings = { columns: [{ field: 'TaskID', direction: 'Descending' }], allowUnsort: true };
}
}Defaults to {columns:[]}
splitterSettings SplitterSettingsModel
Configures the splitter settings for the Gantt chart.
<ejs-gantt [splitterSettings]="splitterSettings"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public splitterSettings: object;
public ngOnInit(): void {
this.splitterSettings = {
position: "50%",
minimum: "200",
separatorSize: 5,
view: 'Default'
}
}
}The position takes precedence over columnIndex when both defined.
taskFields TaskFieldsModel
Defines the mapping properties used to extract task-related values—such as ID, start date, end date, duration, and progress—from the data source.
This ensures that the Gantt chart correctly maps the provided data to the corresponding task fields and renders them accurately.
<ejs-gantt [taskFields]="taskSettings"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public taskSettings: object;
public ngOnInit(): void {
this.taskSettings = {
id: 'TaskID',
name: 'TaskName',
startDate: 'StartDate',
duration: 'Duration',
dependency: 'Predecessor',
progress: 'Progress',
baselineStartDate: 'BaselineStartDate',
baselineEndDate: 'BaselineEndDate',
durationUnit: 'DurationUnit',
expandState: 'isExpand',
indicators: 'Indicators',
milestone: 'Milestone',
notes: 'info',
resourceInfo: 'resourceInfo',
child: 'subtasks',
};
}
}taskMode ScheduleMode
Specifies task schedule mode for a project.
Defaults to ‘Auto’
taskType TaskType
taskType Specifies the task type for task whether fixedUnit or fixedWork or fixedDuration.
-
fixedUnit: Sets the task type as fixedUnit. -
fixedWork: Sets the task type as fixedWork. -
fixedDuration: Sets the task type as fixedDuration.
Defaults to fixedUnit
taskbarHeight number
Defines height of the taskbar element in the Gantt chart.
Defaults to null
taskbarTemplate any
The task bar template that renders customized child task bars from the given template.
This property allows users to define a custom template for rendering child task bars in the Gantt chart.
<ejs-gantt id="ganttDefault">
<ng-template #taskbarTemplate let-data>
<div
class="e-gantt-child-taskbar-inner-div e-gantt-child-taskbar"
style="height:22px; margin-top :-1px"
tabindex="-1"
[style.width.px]="data.ganttProperties.width"
>
<div
class="e-gantt-child-progressbar-inner-div e-gantt-child-progressbar"
style="border-style:solid;height:100%;border-top-right-radius:0px;border-bottom-right-radius:0px;"
[style.width.px]="calculateProgressWidth(data)"
>
<span
class="e-task-label"
style="line-height:21px; text-align:left;display:inline-block;width:122px; height:22px;"
>{{ data.TaskName }}</span
>
</div>
</div>
</ng-template>
</ejs-gantt>import { Component, ViewEncapsulation, OnInit,IGanttData } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public calculateProgressWidth(data:IGanttData) {
// Calculate the progress width based on the taskbar width and progress value
return (data.ganttProperties.progress * data.ganttProperties.width) / 100;
}
public ngOnInit(): void {
}
}Defaults to null
timelineSettings TimelineSettingsModel
Configures timeline settings of Gantt.
Defines default timeline modes or customized top tier mode and bottom tier mode or single tier only.
<ejs-gantt [timelineSettings]="timelineSettings"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public timelineSettings: object;
public ngOnInit(): void {
this.timelineSettings = {
showTooltip: true,
timelineUnitSize: 80,
timelineViewMode: 'Week',
updateTimescaleView: true,
weekStartDay: 0,
weekendBackground: 'red',
topTier: {
format: 'MMM dd, yyyy',
unit: 'Week',
},
bottomTier: {
unit: 'Day',
format: 'EEE, dd',
count: 1,
}
};
}
}timelineTemplate any
Specifies the template used to render custom HTML content in timeline cells.
import { Component } from '@angular/core';
@Component({
selector: 'app-root',
template: `
<ejs-gantt
[dataSource]="data"
[taskFields]="taskFields"
[timelineTemplate]="timelineTemplate"
height="450px">
</ejs-gantt>
`
})
export class AppComponent {
// Your data, taskFields...
public timelineTemplate: any = (props: any) => {
return `<div style="text-align:center; padding:5px;">${props.value}</div>`;
};
}Defaults to null
timezone string
Specifies the time zone used for task date and scheduling calculations in the Gantt chart.
By default, the system or browser time zone is applied.
The time zone always affects internal date calculations (e.g., task start/end times, durations, and dependencies),
even in non-hour views. However, visible changes in timeline and task positions only appear when the timeline
includes an hour-level mode.
To see the time zone reflected in the UI, configure one of these:
timelineViewMode: 'Hour'- or
topTier.unit: 'Day'+bottomTier.unit: 'Hour'
Without an hour view (e.g., only Day/Week/Month views), the chart looks unchanged, but Gantt chart uses the new time zone.
Use standard IANA time zone names (e.g., ‘Asia/Kolkata’, ‘UTC’, ‘America/New_York’).
Defaults to null
toolbar []
toolbar defines the toolbar items of the Gantt.
It contains built-in and custom toolbar items.
If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the Gantt’s toolbar.
The available built-in toolbar items are:
- Add: Adds a new record.
- Edit: Edits the selected task.
- Update: Updates the edited task.
- Delete: Deletes the selected task.
- Cancel: Cancels the edit state.
- Search: Searches tasks by the given key.
- ExpandAll: Expands all the task of Gantt.
- CollapseAll: Collapses all the task of Gantt.
- PrevTimeSpan: Extends timeline with one unit before the timeline start date.
- NextTimeSpan: Extends timeline with one unit after the timeline finish date.
- ZoomIn: ZoomIn the Gantt control.
- ZoomOut: ZoomOut the Gantt control.
- ZoomToFit: Display the all tasks within the viewable Gantt chart.
- ExcelExport: To export in Excel format.
- CsvExport : To export in CSV format.
- Indent: To indent a task to one level.
- Outdent: To outdent a task from one level.
Defaults to null
tooltipSettings TooltipSettingsModel
Enables or disables default tooltip of Gantt element and defines customized tooltip for Gantt elements.
<ejs-gantt [tooltipSettings]="tooltipSettings"></ejs-gantt>import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
@Component({
selector: 'app-root',
templateUrl: "app.component.html",
encapsulation: ViewEncapsulation.None
})
export class AppComponent{
public tooltipSettings: object;
public ngOnInit(): void {
this.tooltipSettings = {
showTooltip: true,
taskbar: '<div>TaskID: ${TaskID}</div>',
connectorLine: '<div>Offset : ${offsetString}</div>',
editing: '<div>Duration : ${duration}</div>',
baseline: '<div>Baseline StartDate : ${this.getFormatedDate(BaselineStartDate)}</div>'
}
}
}Defaults to { showTooltip: true }
treeColumnIndex number
To define expander column index in Grid.
Defaults to 0
undoRedoActions GanttAction[]
undoRedoActions Defines action items that retain for undo and redo operation.
Defaults to [‘Sorting’, ‘Add’, ‘ColumnReorder’, ‘ColumnResize’, ‘ColumnState’, ‘Delete’, ‘Edit’, ‘Filtering’, ‘Indent’, ‘Outdent’, ‘NextTimeSpan’, ‘PreviousTimeSpan’, ‘RowDragAndDrop’, ‘TaskbarDragAndDrop’, ‘Search’, ‘ZoomIn’, ‘ZoomOut’, ‘ZoomToFit’]
undoRedoModule UndoRedo
The undoRedoModule manages the undo and redo functionality in the Gantt chart.
undoRedoStepsCount number
Specifies the number of undo and redo actions to retain in history.
Defaults to 10
updateOffsetOnTaskbarEdit boolean
Specifies whether to update offset value on a task for all the predecessor edit actions.
Defaults to true
validateManualTasksOnLinking boolean
If validateManualTasksOnLinking is set to true,
it enables date validation while connecting manually scheduled tasks with predecessor.
Defaults to false
viewType ViewType
Specifies the view type of the Gantt chart.
Defaults to ‘ProjectView’
virtualScrollModule VirtualScroll
The virtualScrollModule is used to handle virtual scroll in Gantt.
weekWorkingTime WeekWorkingTimeModel[]
Specifies the working days in a week for accurate planning, and works only when the timeline is configured with topTier.unit as ‘Day’ and bottomTier.unit as ‘Hour’ or when timelineViewMode is set to ‘Hour’ or ‘Day’.
width number|string
Defines the width of the Gantt component container.
Defaults to ‘auto’
workUnit WorkUnit
workUnit Specifies the work unit for each tasks whether day or hour or minute.
-
day: Sets the work unit as day. -
hour: Sets the work unit as hour. -
minute: Sets the work unit as minute.
Defaults to hour
workWeek string[]
Specifies the project’s workweek (working days).
workWeek specifies the days of the week that are considered working days for the project.
Defaults to [‘Monday’, ‘Tuesday’, ‘Wednesday’, ‘Thursday’, ‘Friday’]
zoomingLevels ZoomTimelineSettings[]
Defines the available zoom levels for the Gantt timeline.
Provide an array of ZoomTimelineSettings to control the scale and intervals used when zooming.
Defaults to []
Methods
addPredecessor
To add dependency for Task.
| Parameter | Type | Description |
|---|---|---|
| id |
number | string
|
Defines the ID of data to modify. |
| predecessorString | string |
Defines the predecessor string to add. |
Returns void
addRecord
Method to add record.
| Parameter | Type | Description |
|---|---|---|
| data (optional) |
Object[] | IGanttData | Object
|
Defines record to add. |
| rowPosition (optional) | RowPosition |
Defines the position of row. |
| rowIndex (optional) | number |
Defines the row index. |
Returns void
autoFitColumns
Adjusts the width of specified columns to fit their content, preventing wrapping or truncation.
Hidden columns are ignored. For initial rendering, call this method during the dataBound event.
| Parameter | Type | Description |
|---|---|---|
| fieldNames (optional) |
string | string[]
|
The name(s) of the column(s) to auto-fit. Accepts a single column name or an array of column names. |
Returns void
cancelEdit
Cancels the current edit operation and reverts the changes made during editing.
Returns void
changeTaskMode
To change the mode of a record.
| Parameter | Type | Description |
|---|---|---|
| data | Object |
Use to change the TaskMode either manual, auto or custom. |
Returns void
clearFiltering
Clears the filtered columns in Gantt.
Can also be used to clear filtering of a specific column in Gantt.
| Parameter | Type | Description |
|---|---|---|
| fields (optional) | string[] |
Defines the specific column to remove filter. |
Returns void
clearRedoCollection
Clears the stack collection for redo action.
Returns void
clearSelection
Deselects the current selected rows and cells.
Returns void
clearSorting
Clears all the sorted columns of the Gantt.
Returns void
clearUndoCollection
Clears the stack collection for undo action.
Returns void
collapseAll
Method to collapse all the rows of Gantt.
Returns void
collapseByID
Collapse the record by id value.
| Parameter | Type | Description |
|---|---|---|
| id |
number | string
|
Defines the id of task. |
Returns void
collapseByIndex
Collapse the record by index value.
| Parameter | Type | Description |
|---|---|---|
| index | number |
Defines the index of row. |
Returns void
convertToMilestone
Method to convert task data to milestone data.
| Parameter | Type | Description |
|---|---|---|
| id | string |
Defines id of record. |
Returns void
csvExport
Export Gantt data to CSV file.
| Parameter | Type | Description |
|---|---|---|
| excelExportProperties (optional) | ExcelExportProperties |
Defines the export properties of the Gantt. |
| isMultipleExport (optional) | boolean |
Define to enable multiple export. |
| workbook (optional) | any |
Defines the Workbook if multiple export is enabled. |
| isBlob (optional) | boolean |
If ‘isBlob’ set to true, then it will be returned as blob data. |
Returns Promise
deleteRecord
Method to delete record.
| Parameter | Type | Description |
|---|---|---|
| taskDetail |
number | string | number[] | string[] | IGanttData | IGanttData[]
|
Defines the details of data to delete. |
Returns void
enableItems
Enables or disables ToolBar items.
| Parameter | Type | Description |
|---|---|---|
| items | string[] |
Defines the collection of itemID of ToolBar items. |
| isEnable | boolean |
Defines the items to be enabled or disabled. |
Returns void
excelExport
Export Gantt data to Excel file(.xlsx).
| Parameter | Type | Description |
|---|---|---|
| excelExportProperties (optional) | ExcelExportProperties |
Defines the export properties of the Gantt. |
| isMultipleExport (optional) | boolean |
Define to enable multiple export. |
| workbook (optional) | any |
Defines the Workbook if multiple export is enabled. |
| isBlob (optional) | boolean |
If ‘isBlob’ set to true, then it will be returned as blob data. |
Returns Promise
expandAll
Method to expand all the rows of Gantt.
Returns void
expandByID
Expand the record by task id.
| Parameter | Type | Description |
|---|---|---|
| id |
number | string
|
Defines the id of task. |
Returns void
expandByIndex
Expand the records by index value.
| Parameter | Type | Description |
|---|---|---|
| index |
number[] | number
|
Defines the index of rows to be expand. |
Returns void
filterByColumn
Filters TreeGrid row by column name with the given options.
| Parameter | Type | Description |
|---|---|---|
| fieldName | string |
Defines the field name of the column. |
| filterOperator | string |
Defines the operator to filter records. |
| filterValue |
string | number | Date | boolean | number[] | string[] | Date[] | boolean[]
|
Defines the value used to filter records. |
| predicate (optional) | string |
Defines the relationship between one filter query and another by using AND or OR predicate. |
| matchCase (optional) | boolean |
If match case is set to true, TreeGrid filters the records with exact match.if false, it filters case insensitive records (uppercase and lowercase letters treated the same). |
| ignoreAccent (optional) | boolean |
If ignoreAccent set to true, then filter ignores the diacritic characters or accents while filtering. |
Returns void
fitToProject
To show all project task in available chart width.
Returns void
getCriticalTasks
To get all the critical tasks in Gantt.
Returns IGanttData[]
getCurrentViewData
Retrieves the current view data, reflecting the latest state after filtering, sorting, and CRUD operations.
Returns Object[]
getDurationString
Get duration value as string combined with duration and unit values.
| Parameter | Type | Description |
|---|---|---|
| duration | number |
Defines the duration. |
| durationUnit | string |
Defines the duration unit. |
Returns string
getExpandedRecords
Get expanded records from given record collection.
| Parameter | Type | Description |
|---|---|---|
| records | IGanttData[] |
Defines record collection. |
Returns IGanttData[]
getGanttColumns
Gets the Gantt columns.
Returns ColumnModel[]
getGridColumns
Gets the columns from the TreeGrid.
Returns Column[]
getRecordByID
Method to get record by id value.
| Parameter | Type | Description |
|---|---|---|
| id | string |
Defines the id of record. |
Returns IGanttData
getRedoActions
To retrieve the collection of actions to reapply.
modifiedRecords - retrieves the modified records.
action - shows the current performed action such as ‘sorting’,’columnReorder’,’columnResize’,’progressResizing’,’rightResizing’,’leftResizing’,’add’,’delete’,’search’,’filtering’,’zoomIn’,’zoomOut’,’zoomToFit’,’columnState’,’previousTimeSpan’,’nextTimeSpan’,’indent’,’outdent’,’rowDragAndDrop’,’taskbarDragAndDrop’,’dialogEdit’
Returns Object[]
getRowByID
Method to get the row element by task id.
| Parameter | Type | Description |
|---|---|---|
| id |
string | number
|
Defines the id of task. |
Returns HTMLElement
getRowByIndex
Method to get chart row value by index.
| Parameter | Type | Description |
|---|---|---|
| index | number |
Defines the index of row. |
Returns HTMLElement
getTaskByUniqueID
Method to get task by uniqueId value.
| Parameter | Type | Description |
|---|---|---|
| id | string |
Defines the task id. |
Returns IGanttData
getTaskInfo
Retrieves the internal Gantt properties for a task using its Task ID.
This method provides access to task data such as taskbar width, left position, segments collection etc.,.
| Parameter | Type | Description |
|---|---|---|
| taskId | string |
The unique identifier of the task. |
Returns IGanttTaskInfo
getTaskbarHeight
Method to get taskbarHeight.
Returns number
getUndoActions
To retrieve the collection of previously recorded actions. This method returns an object as a collection that holds the following details.
modifiedRecords - retrieves the modified records.
action - shows the current performed action such as ‘sorting’,’columnReorder’,’columnResize’,’progressResizing’,’rightResizing’,’leftResizing’,’add’,’delete’,’search’,’filtering’,’zoomIn’,’zoomOut’,’zoomToFit’,’columnState’,’previousTimeSpan’,’nextTimeSpan’,’indent’,’outdent’,’rowDragAndDrop’,’taskbarDragAndDrop’,’dialogEdit’
Returns Object[]
getWorkString
Get work value as string combined with work and unit values.
| Parameter | Type | Description |
|---|---|---|
| work | number |
Defines the work value. |
| workUnit | string |
Defines the work unit. |
Returns string
hideColumn
Hides one or more columns in the Gantt chart based on the specified column names or header texts.
| Parameter | Type | Description |
|---|---|---|
| keys |
string | string[]
|
Defines a single or collection of column names. |
| hideBy (optional) | string |
Defines the column key either as field name or header text. |
Returns void
hideSpinner
Method used to hide spinner.
Returns void
indent
To indent the level of selected task to the hierarchical Gantt task.
Returns void
mergeTask
Merge the split taskbar with the given segment indexes.
| Parameter | Type | Description |
|---|---|---|
| taskId |
number | string
|
Defines the id of a task to be split. |
| segmentIndexes | Object[] |
Defines the object array of indexes which must be merged. |
Returns void
nextTimeSpan
To update timeline at end point with one unit.
| Parameter | Type | Description |
|---|---|---|
| mode (optional) | string |
Render next span of Timeline. |
Returns void
openAddDialog
Method to open Add dialog.
Returns void
openEditDialog
Method to open Edit dialog.
| Parameter | Type | Description |
|---|---|---|
| taskId (optional) |
number | string
|
Defines the id of task. |
Returns void
outdent
To outdent the level of selected task from the hierarchical Gantt task.
Returns void
pdfExport
Export Gantt data to PDF document.
| Parameter | Type | Description |
|---|---|---|
| pdfExportProperties (optional) | PdfExportProperties |
Defines the export properties of the Gantt. |
| isMultipleExport (optional) | boolean |
Define to enable multiple export. |
| pdfDoc (optional) | Object |
Defined the Pdf Document if multiple export is enabled. |
| isBlob (optional) | boolean |
If the ‘isBlob’ parameter is set to true, the method returns PDF data as a blob instead of exporting it as a down-loadable PDF file. The default value is false. |
Returns Promise
previousTimeSpan
Updates the Gantt timeline to the previous time span by one unit.
| Parameter | Type | Description |
|---|---|---|
| mode (optional) | string |
Render previous span of Timeline. |
Returns void
redo
Initiates a redo action to reapply the most recent undone change performed.
Returns void
refreshColumns
Refreshes the column definitions and layout of the TreeGrid pane.
Applies any changes made to column configurations such as visibility, order, or width.
If refreshUI is set to true, the DOM is updated to reflect the latest column settings.
Returns void
removePredecessor
To remove dependency from task.
| Parameter | Type | Description |
|---|---|---|
| id |
number | string
|
Defines the ID of the task from which the dependency will be removed. |
Returns void
removeSortColumn
To remove sorted records of particular column.
| Parameter | Type | Description |
|---|---|---|
| columnName | string |
Defines the sorted column name. |
Returns void
reorderColumns
Changes the TreeGrid column positions by field names.
| Parameter | Type | Description |
|---|---|---|
| fromFName |
string | string[]
|
Defines origin field name. |
| toFName | string |
Defines destination field name. |
Returns void
reorderRows
Reorder the rows based on given indexes and position.
| Parameter | Type | Description |
|---|---|---|
| fromIndexes | number[] |
Defines the indexes of the dragged records. |
| toIndex | number |
Defines the index where the dragged rows will be dropped. |
| position | string |
Defines the position of the dropped row. |
Returns void
scrollToDate
Scrolls the Gantt chart’s timeline horizontally to bring the specified date into view.
This method is useful for navigating directly to a task, milestone, or any specific time range.
| Parameter | Type | Description |
|---|---|---|
| date |
string | Date
|
The target date to scroll to. Accepts a date string or a JavaScript Date object. |
Returns void
scrollToTask
To move horizontal scroll bar of Gantt to specific task id.
| Parameter | Type | Description |
|---|---|---|
| taskId | string |
Defines the task id of data. |
Returns void
search
Method to perform search action in Gantt.
| Parameter | Type | Description |
|---|---|---|
| keyVal | string |
Defines key value to search. |
Returns void
selectCell
Selects a cell by the given index.
| Parameter | Type | Description |
|---|---|---|
| cellIndex | IIndex |
Defines the row and column indexes. |
| isToggle (optional) | boolean |
If set to true, then it toggles the selection. |
Returns void
selectCells
Selects a collection of cells by row and column indexes.
| Parameter | Type | Description |
|---|---|---|
| rowCellIndexes | ISelectedCell[] |
Specifies the row and column indexes. |
Returns void
selectRow
Selects a row by given index.
| Parameter | Type | Description |
|---|---|---|
| index | number |
Defines the row index. |
| isToggle (optional) | boolean |
If set to true, then it toggles the selection. |
Returns void
selectRows
Selects a collection of rows by indexes.
| Parameter | Type | Description |
|---|---|---|
| records | number[] |
Defines the collection of row indexes. |
Returns void
setScrollTop
To set scroll top for chart scroll container.
| Parameter | Type | Description |
|---|---|---|
| scrollTop | number |
Defines scroll top value for scroll container. |
Returns void
setSplitterPosition
Method to set splitter position.
| Parameter | Type | Description |
|---|---|---|
| value |
string | number
|
Define value to splitter settings property. |
| type | string |
Defines name of internal splitter settings property. |
Returns void
showColumn
Shows a column by its column name.
| Parameter | Type | Description |
|---|---|---|
| keys |
string | string[]
|
Defines a single or collection of column names. |
| showBy (optional) | string |
Defines the column key either as field name or header text. |
Returns void
showSpinner
Method used to show spinner.
Returns void
sortColumn
Sorts a column with the given options.
| Parameter | Type | Description |
|---|---|---|
| columnName | string |
Defines the column name to be sorted. |
| direction | SortDirection |
Defines the direction of sorting field. |
| isMultiSort (optional) | boolean |
Specifies whether the previous sorted columns are to be maintained. |
Returns void
splitTask
Splits the taskbar of a specified task into segments based on the given date.
| Parameter | Type | Description |
|---|---|---|
| taskId |
number | string
|
Defines the id of a task to be split. |
| splitDate |
Date | Date[]
|
Defines in which date the taskbar must be split up. |
Returns void
undo
Initiates an undo action to revert the most recent change performed.
Returns void
updateChartScrollOffset
To update the horizontal (left) and vertical (top) scroll positions of the Gantt chart.
| Parameter | Type | Description |
|---|---|---|
| left | number |
Defines the scroll left value of chart side. |
| top | number |
Defines the scroll top value of chart side. |
Returns void
updateDataSource
Method to update data source.
| Parameter | Type | Description |
|---|---|---|
| dataSource | Object[] |
Defines a collection of data. |
| args | object |
Defines the projectStartDate and projectEndDate values. |
Returns void
updatePredecessor
To modify current dependency values of Task by task id.
| Parameter | Type | Description |
|---|---|---|
| id |
number | string
|
Defines the ID of data to modify. |
| predecessorString | string |
Defines the predecessor string to update. |
Returns void
updateProjectDates
To validate project start date and end date.
| Parameter | Type | Description |
|---|---|---|
| startDate | Date |
Defines start date of project. |
| endDate | Date |
Defines end date of project. |
| isTimelineRoundOff | boolean |
Defines project start date and end date need to be round off or not. |
| isFrom (optional) | string |
Defines whether the call originates from a public method action or a taskbar editing action. |
Returns void
updateRecordByID
Method to update record by ID.
| Parameter | Type | Description |
|---|---|---|
| data | Object |
Defines the data to modify. |
Returns void
updateRecordByIndex
Method to update record by Index.
| Parameter | Type | Description |
|---|---|---|
| index | number |
Defines the index of data to modify. |
| data | Object |
Defines the data to modify. |
Returns void
updateTaskId
To update existing taskId with new unique Id.
| Parameter | Type | Description |
|---|---|---|
| currentId |
number | string
|
Defines the current Id of the record. |
| newId |
number | string
|
Defines the new Id of the record. |
Returns void
zoomIn
To perform Zoom in action on Gantt timeline.
Returns void
zoomOut
To perform zoom out action on Gantt timeline.
Returns void
Events
actionBegin EmitType<Object|FilterEventArgs|SortEventArgs|ITimeSpanEventArgs|IDependencyEventArgs|ITaskAddedEventArgs|ZoomEventArgs>
Event triggered when a Gantt action (sorting, filtering, searching, etc.) begins.
Allows cancellation or modification of the action.
actionComplete EmitType<FilterEventArgs|SortEventArgs|ITaskAddedEventArgs|IKeyPressedEventArgs|ZoomEventArgs>
Event triggered after a Gantt action (sorting, filtering, etc.) has completed.
Provides updated state after the action.
actionFailure EmitType<FailureEventArgs>
Event triggered when a Gantt action fails during execution.
Provides error details.
beforeDataBound EmitType<BeforeDataBoundArgs>
Event triggered before data is bound to the TreeGrid.
Allows modification of data before rendering begins.
beforeExcelExport EmitType<Object>
Event triggered before Gantt data is exported to Excel.
Allows modification or cancellation of the export process.
beforePdfExport EmitType<Object>
Event triggered before Gantt data is exported to PDF.
Allows modification or cancellation of PDF export.
beforeTooltipRender EmitType<BeforeTooltipRenderEventArgs>
Event triggered before a tooltip is rendered.
Allows customization of tooltip content or cancellation.
cellDeselected EmitType<CellDeselectEventArgs>
Event triggered after a cell has been deselected.
cellDeselecting EmitType<CellDeselectEventArgs>
Event triggered before a selected cell is deselected.
Allows cancellation of cell deselection.
cellEdit EmitType<CellEditArgs>
Event triggered when a cell enters edit mode in the Gantt chart.
Allows customization or cancellation of editing.
cellSave EmitType<CellSaveArgs>
Event triggered before a cell value is saved during editing.
Allows cancellation or modification of the save operation.
cellSelected EmitType<CellSelectEventArgs>
Event triggered after a cell has been selected.
cellSelecting EmitType<CellSelectingEventArgs>
Event triggered before a cell is selected.
Allows cancellation of cell selection.
collapsed EmitType<ICollapsingEventArgs>
Event triggered after a row has been collapsed.
Indicates the collapse action has completed.
collapsing EmitType<ICollapsingEventArgs>
Event triggered before a row is collapsed.
Allows cancellation of the collapse action.
columnDrag EmitType<ColumnDragEventArgs>
Event triggered continuously while a column header is being dragged.
columnDragStart EmitType<ColumnDragEventArgs>
Event triggered when column header drag starts.
columnDrop EmitType<ColumnDragEventArgs>
Event triggered when a dragged column header is dropped.
columnMenuClick EmitType<ColumnMenuClickEventArgs>
Event triggered when an item in the column menu is clicked.
columnMenuOpen EmitType<ColumnMenuOpenEventArgs>
Event triggered before the column menu is opened.
Allows customization or cancellation of menu display.
contextMenuClick EmitType<CMenuClickEventArgs>
Event triggered when an item in the context menu is clicked.
contextMenuOpen EmitType<CMenuOpenEventArgs>
Event triggered before the context menu is opened.
Allows customization or cancellation.
created EmitType<Object>
Event triggered after the Gantt component is fully created and initialized.
dataBound EmitType<Object>
Event triggered after the data source is bound to the TreeGrid part of Gantt.
Indicates data binding is complete.
dataSourceChanged EmitType<DataSourceChangedEventArgs>
Triggers when data in the Gantt is added, deleted, or updated.
Invoke the done method from the argument to start rendering after an edit operation.
dataStateChange EmitType<DataStateChangeEventArgs>
Event triggered after actions like sorting, filtering complete.
Used to update the dataSource with current view data and record count.
destroyed EmitType<Object>
Event triggered when the Gantt component is being destroyed.
Allows cleanup operations.
endEdit EmitType<ITaskbarEditedEventArgs>
Event triggered when a task is saved through cell editing.
Provides updated task data after save.
excelExportComplete EmitType<ExcelExportCompleteArgs>
Event triggered after Gantt data has been successfully exported to Excel.
Provides access to the generated workbook.
excelHeaderQueryCellInfo EmitType<ExcelHeaderQueryCellInfoEventArgs>
Event triggered before each header cell is exported to Excel.
Allows customization of header cell content or styling.
excelQueryCellInfo EmitType<ExcelQueryCellInfoEventArgs>
Event triggered before each cell (header or data) is exported to Excel.
Allows customization of cell content, style, or value.
expanded EmitType<ICollapsingEventArgs>
Event triggered after a row has been expanded.
Indicates the expand action has completed.
expanding EmitType<ICollapsingEventArgs>
Event triggered before a row is expanded.
Allows cancellation of the expand action.
headerCellInfo EmitType<HeaderCellInfoEventArgs>
Event triggered before each header cell element is rendered.
Allows customization of header cell content or style.
load EmitType<Object>
Event triggered when the Gantt component begins loading data.
Occurs before any rendering starts.
onMouseMove EmitType<IMouseMoveEventArgs>
Event triggered on mouse move over the Gantt component.
Provides mouse position and target information.
onTaskbarClick EmitType<ITaskbarClickEventArgs>
Event triggered when a taskbar element is clicked.
Provides task and click details.
pdfColumnHeaderQueryCellInfo EmitType<PdfColumnHeaderQueryCellInfoEventArgs>
Event triggered before each column header cell is exported to PDF.
Allows customization of header cell content or style.
pdfExportComplete EmitType<Object>
Event triggered after Gantt data has been exported to PDF.
Provides access to the generated document.
pdfQueryCellInfo EmitType<PdfQueryCellInfoEventArgs>
Event triggered before each cell is exported to PDF.
Allows customization of cell content or style.
pdfQueryTaskbarInfo EmitType<Object>
Event triggered before each taskbar is exported to PDF.
Allows customization of taskbar appearance in PDF.
pdfQueryTimelineCellInfo EmitType<PdfQueryTimelineCellInfoEventArgs>
Event triggered before each timeline cell is exported to PDF.
Allows customization of timeline cell content or style.
queryCellInfo EmitType<QueryCellInfoEventArgs>
Event triggered before each cell element is rendered.
Allows customization of cell content or style.
queryTaskbarInfo EmitType<IQueryTaskbarInfoEventArgs>
Event triggered per taskbar before rendering in the Gantt chart.
Used to customize taskbar styles and properties dynamically.
recordDoubleClick EmitType<RecordDoubleClickEventArgs>
Event triggered when a record is double-clicked.
resizeStart EmitType<ResizeArgs>
Event triggered when column resizing starts in the Grid.
resizeStop EmitType<ResizeArgs>
Event triggered when column resizing completes.
resizing EmitType<ResizeArgs>
Event triggered continuously while a column is being resized.
rowDataBound EmitType<RowDataBoundEventArgs>
Event triggered before each row element is rendered.
Allows customization of row appearance.
rowDeselected EmitType<RowDeselectEventArgs>
Event triggered after a row has been deselected.
rowDeselecting EmitType<RowDeselectEventArgs>
Event triggered before a selected row is deselected.
Allows cancellation of deselection.
rowDrag EmitType<RowDragEventArgs>
Event triggered continuously while row elements are being dragged.
Provides current drag position and target information.
rowDragStart EmitType<RowDragEventArgs>
Event triggered when a row drag operation starts.
Provides initial drag source details.
rowDragStartHelper EmitType<RowDragEventArgs>
Event triggered before the row drag operation officially begins.
Allows preparation or cancellation of the drag action.
rowDrop EmitType<RowDragEventArgs>
Event triggered when dragged row elements are dropped onto a target row.
Provides source and target row information for reordering/indent/outdent.
rowSelected EmitType<RowSelectEventArgs>
Event triggered after a row has been selected.
rowSelecting EmitType<RowSelectingEventArgs>
Event triggered before a row is selected.
Allows cancellation of selection.
splitterResizeStart EmitType<ResizeEventArgs>
Event triggered when splitter resizing begins in the Gantt component.
splitterResized EmitType<ISplitterResizedEventArgs>
Event triggered when splitter resizing action completes.
splitterResizing EmitType<ResizingEventArgs>
Event triggered continuously while the splitter bar is being dragged.
taskbarEdited EmitType<ITaskbarEditedEventArgs>
Event triggered after a taskbar has been dragged and dropped to a new position.
Indicates editing via taskbar has completed.
taskbarEditing EmitType<ITaskbarEditedEventArgs>
Event triggered while a taskbar is being dragged.
Provides current drag progress and position.
toolbarClick EmitType<ClickEventArgs>
Event triggered when a toolbar item is clicked.

GanttComponent

9 Jul 202624 minutes to read

GanttComponent represents the react Gantt.

<GanttComponent dataSource={data} allowSelection={true} allowSorting={true}/>

Properties

addDialogFields AddDialogFieldSettingsModel[]

Defines the tabs and fields to be displayed in the add dialog.
If not specified, the fields will be derived from the taskSettings and columns values.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, AddDialogFieldsDirective, AddDialogFieldDirective } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
    }
    render() {
        return <GanttComponent>
        <AddDialogFieldsDirective>
            <AddDialogFieldDirective type='General' headerText='General' fields={['TaskID', 'TaskName']}></AddDialogFieldDirective>
            <AddDialogFieldDirective type='Dependency'></AddDialogFieldDirective>
            <AddDialogFieldDirective type='Resources'></AddDialogFieldDirective>
            <AddDialogFieldDirective type='Notes'></AddDialogFieldDirective>
        </AddDialogFieldsDirective>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to []

allowExcelExport boolean

Enables exporting the Gantt chart to Excel (.xlsx) and CSV formats.
When set to true, users can export the chart data.

Defaults to false

allowFiltering boolean

Enables or disables filtering functionality in the Gantt chart.

Defaults to false

allowKeyboard boolean

Enables or disables keyboard interactions in the Gantt chart.

Defaults to true

allowParentDependency boolean

Specifies whether dependency connections are supported for parent tasks.
Only allows dependencies between tasks belonging to different parents.
Dependencies within the same parent are not supported.

Defaults to true

allowPdfExport boolean

If allowPdfExport set to true, then it will allow the user to export Gantt chart to PDF file.

Defaults to false

allowReordering boolean

If allowReordering is set to true, Gantt chart columns can be reordered.
Reordering can be done by drag and drop of a particular column from one index to another index.

Defaults to false

allowResizing boolean

Enables column resizing in the Gantt chart when allowResizing is set to true.
When enabled, users can adjust the width of columns by dragging the column borders.

Defaults to false

allowRowDragAndDrop boolean

If allowRowDragAndDrop set to true, then it will allow the user to perform row drag and drop action in Gantt chart.

Defaults to false

allowSelection boolean

Specifies whether to enable row selection in the Gantt chart. When enabled, selected rows are highlighted.

Defaults to true

allowSorting boolean

If allowSorting is set to true, it enables sorting of Gantt chart tasks when the column header is clicked.

Defaults to false

allowTaskbarDragAndDrop boolean

Specifies whether taskbar drag and drop is enabled in the Gantt chart.

Defaults to false

allowTaskbarOverlap boolean

Specifies whether taskbars can overlap in the Gantt chart. To enable overlapping behavior, use this property along with enableMultiTaskbar.

Defaults to true

allowUnscheduledTasks boolean

Enables or disables the rendering of unscheduled tasks in the Gantt chart.
When allowUnscheduledTasks set to true, unscheduled tasks will be displayed in the chart.

Defaults to false

autoCalculateDateScheduling boolean

Specifies whether to auto calculate the start and end dates based on factors such as working time, holidays, weekends, and task dependencies.

Defaults to true

autoFocusTasks boolean

Specifies whether to automatically scroll the corresponding taskbar into view when a task is selected.

Defaults to true

autoUpdatePredecessorOffset boolean

Determines whether to automatically validate and update predecessor offsets in the IPredecessor collection and columns during initial load.
When true, ensures data consistency with rendering validations.

Defaults to false

baselineColor string

Specifies the color of the baseline bar in the Gantt chart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent,IGanttData } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
  }
    }
    render() {
        return <GanttComponent renderBaseline={true} baselineColor='red' >
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to null

baselineTemplate string|Function

.
Accepts an element ID selector, HTML string, or function returning string or HTMLElement.
Defines a custom template for rendering baseline bars in the Gantt chart.

Defaults to null

calendarSettings CalendarSettingsModel

Defines the calendar configuration for the project, including working times, holidays, and task-specific calendars.
This setting enables customization of scheduling behavior across the Gantt chart, including:

  • Global working hours and non-working days
  • Holiday definitions with localized labels
  • Task-level calendar overrides via taskFields.calendarId

Defaults to {}

collapseAllParentTasks boolean

Defines whether all root tasks should be rendered in a collapsed state. When collapseAllParentTasks set to true, all parent tasks will be collapsed by default.

Defaults to false

columnMenuItems []

columnMenuItems defines both built-in and custom menu items for the Gantt chart column menu.



The available built-in items are,

  • ColumnChooser - To show/hide the TreeGrid columns.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the size of the current column.
  • Filter - Displays filter options based on the filterSettings property.

Defaults to null

columnMenuModule ColumnMenu

The columnMenuModule is used to manage and customize the column menu in the Gantt chart.

columns Column[]|string[]|ColumnModel[]

Defines the collection of columns displayed in the Gantt chart grid.
If the columns declaration is empty, the columns are automatically populated based on the taskSettings values.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
    }
    render() {
        return <GanttComponent>
            <ColumnsDirective>
                <ColumnDirective field='TaskID' width='150' headerText='Task ID' headerTextAlign='Left' allowFiltering= 'false'></ColumnDirective>
                <ColumnDirective field='TaskName' clipMode='EllipsisWithTooltip' allowEditing='true' hideAtMedia='(min-width: 700px)'></ColumnDirective>
                <ColumnDirective field='Duration' edittype='stringedit' allowReordering='true' maxWidth= '400'></ColumnDirective>
                <ColumnDirective field='Progress' textAlign='Right' allowResizing='false' visible='true' format='C'></ColumnDirective>
                <ColumnDirective field='StartDate' width='250' allowSorting='false' minWidth='200'><ColumnDirective>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to []

connectorLineBackground string

Specifies the background color of dependency (connector) lines in the Gantt chart.
Accepts any valid CSS color value (for example: “red”, “#FF5733”, “rgb(255, 0, 0)”).

Defaults to null

connectorLineWidth number

Defines the width of the dependency lines in the Gantt chart.
The value should be a positive integer, representing the thickness of the lines.

Defaults to 1

contextMenuItems ContextMenuItem[]|ContextMenuItemModel[]

Defines the built-in and custom items that appear in the context menu of the Gantt chart.
You can use this property to control the content and functionality of the right-click context menu.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, ContextMenu } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.contextMenuItems = ['AutoFitAll', 'AutoFit', 'TaskInformation', 'DeleteTask', 'Save', 'Cancel', 'SortAscending', 'SortDescending', 'Add', 'DeleteDependency', 'Convert',
            { text: 'Collapse the Row', target: '.e-content', id: 'collapserow' },
            { text: 'Expand the Row', target: '.e-content', id: 'expandrow' },
        ];
    }
    render() {
        return <GanttComponent contextMenuItems={this.contextMenuItems}>
        <Inject services={[ContextMenu]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to null

contextMenuModule ContextMenu

The contextMenuModule is responsible for managing and invoking the context menu in the Gantt chart.
It provides the functionality to display and interact with the context menu, which can be customized using the contextMenuItems property.

criticalPathModule CriticalPath

The criticalPathModule is used to determine the critical path in the Gantt chart.
It identifies the sequence of tasks that directly affect the project’s duration and highlights them.

currentZoomingLevel ZoomTimelineSettings

Specifies the current zooming level of the Gantt chart.

dataSource Object[]|DataManager|Object

Defines the data source for the Gantt chart, which is used to render rows and tasks.
The dataSource can be an array of JavaScript objects, an instance of DataManager, or a single object.
The array of objects should contain the task data with properties such as TaskID, TaskName, StartDate, EndDate, etc.
This allows dynamic binding of tasks and their relationships (e.g., dependencies, subtasks, progress) to the Gantt chart.

// Hierarchical data binding.
let dataSource = [
    {
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 }
        ]
    },
];
// Self-referential data binding (Flat data).
let dataSource = [
    { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
    { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50, ParentId: 1 },
    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50, ParentId: 1 }
];
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        // Remote data
         this.dataSource = new DataManager({
            url: 'https://ej2services.syncfusion.com/production/web-services/api/GanttData',
            adaptor: new WebApiAdaptor,
            crossDomain: true
        });
    }
    render() {
        return <GanttComponent dataSource={this.dataSource}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to []

dateFormat string

Specifies the date format for displaying dates in the Gantt chart, including in tooltips and grid cells.
By default, the format is determined based on the current culture/locale settings.

dayMarkersModule DayMarkers

The dayMarkersModule is used to manage and manipulate event markers in the Gantt chart.
It allows customization of how markers are displayed on specific days, helping to highlight important dates or milestones.

dayWorkingTime DayWorkingTimeModel[]

Defines the customized working time for the project to ensure accurate task scheduling, and works only when the timeline is configured with topTier.unit as ‘Day’ and bottomTier.unit as ‘Hour’ or when timelineViewMode is set to ‘Hour’ or ‘Day’.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        public dayWorkingTime: any = [{ from: 9, to: 18 }];
    }
    render() {
        return <GanttComponent dayWorkingTime={this.dayWorkingTime}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

disableHtmlEncode boolean

If disableHtmlEncode is set to true, the Gantt component disables HTML entity encoding across the Gantt content, allowing custom HTML elements to be rendered.

Defaults to true

durationUnit DurationUnit

durationUnit Specifies the duration unit for each task. The available options are:

  • day: Sets the duration unit to day.
  • hour: Sets the duration unit to hour.
  • minute: Sets the duration unit to minute.

Defaults to day

editDialogFields EditDialogFieldSettingsModel[]

Defines the tabs and fields to be displayed in the edit dialog.
If not specified, the fields will be derived from the taskSettings and columns values.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, EditDialogFieldsDirective, EditDialogFieldDirective } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
    }
    render() {
        return <GanttComponent>
        <EditDialogFieldsDirective>
            <EditDialogFieldDirective type='General' headerText='General' fields={['TaskID', 'TaskName']}></EditDialogFieldDirective>
            <EditDialogFieldDirective type='Dependency'></EditDialogFieldDirective>
            <EditDialogFieldDirective type='Resources'></EditDialogFieldDirective>
            <EditDialogFieldDirective type='Notes'></EditDialogFieldDirective>
        </EditDialogFieldsDirective>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to []

editModule Edit

The editModule handles the manipulation of Gantt chart records, including editing, updating, and deleting tasks.

editSettings EditSettingsModel

Configures the edit settings for the Gantt chart, such as enabling or disabling task modifications.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Edit } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.editSettings = {
            allowAdding: true,
            allowEditing: true,
            allowDeleting: true,
            allowTaskbarEditing: true,
            mode:'Auto',
            newRowPosition: 'Top',
            showDeleteConfirmDialog: true
        };
    }
    render() {
        return <GanttComponent editSettings={this.editSettings}>
        <Inject services={[Edit]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to { allowAdding: false, allowEditing: false, allowDeleting: false, mode:’Auto’,showDeleteConfirmDialog: false }

emptyRecordTemplate string|Function

Defines a custom template to display when the Gantt chart has no records.
This template replaces the default empty record message and can include text, HTML elements, or images.
Accepts either a template string or an HTML element ID.

Defaults to null

enableAdaptiveUI boolean

Specifies whether to enable an adaptive UI mode, which optimizes the layout of pop-ups for filtering, editing, and other features on smaller screens, such as mobile devices. *

Defaults to false

enableAutoWbsUpdate boolean

Enables the automatic update of WBS codes when performing actions like sorting, filtering, row drag and drop, and other grid operations that change the task order or hierarchy.
When set to true, the Gantt component will refresh and regenerate the WBS codes dynamically after such actions to ensure the codes remain in sync with the current task structure.

Defaults to false

enableContextMenu boolean

If enableContextMenu is set to true, enables the context menu in the Gantt chart.
The context menu provides additional actions that can be accessed by right-clicking on Gantt chart elements

Defaults to false

enableCriticalPath boolean

Enables the highlighting of critical tasks in the Gantt Chart that directly affect the project’s end date.
When enabled, tasks that are critical to the project timeline will be visually distinguished by colours.

Defaults to false

enableHover boolean

If enableHover is set to true, it enables hover in the Gantt chart and highlights the rows, chart rows, header cells and timeline cells.

Defaults to false

enableHtmlSanitizer boolean

Specifies whether to display or remove the untrusted HTML values in the TreeGrid component.
If enableHtmlSanitizer set to true, any potentially harmful strings and scripts are sanitized before rendering.

Defaults to true

enableImmutableMode boolean

If enableImmutableMode is set to true, the Gantt Chart will reuse existing rows from previous results instead of
performing a full refresh when Gantt actions are executed.

Defaults to false

enableInfiniteTimelineScroll boolean

Enables infinite horizontal scrolling for the Gantt timeline by dynamically
extending the timeline when the scroll reaches the end.

Defaults to false

enableMultiTaskbar boolean

Enables the rendering of child taskbars on the parent row when it is in a collapsed state in the Gantt chart.

Defaults to false

enablePersistence boolean

Enable or disable persisting component’s state between page reloads.

Defaults to false

enablePredecessorValidation boolean

If enablePredecessorValidation is set to true, enables validation for predecessor links in the Gantt chart.

Defaults to true

enableRtl boolean

Enable or disable rendering component in right to left direction.

Defaults to false

enableTimelineVirtualization boolean

Enables better performance for projects with a large time span by initially rendering only the visible timeline cells when enableVirtualization is enabled.
Subsequent cells are loaded on horizontal scrolling.

Defaults to false

enableUndoRedo boolean

enableUndoRedo enables or disables the undo/redo functionality in the Gantt chart.
Enables undo and redo in the Gantt chart. When set to true, users can
revert or reapply recent changes.

Defaults to false

enableVirtualMaskRow boolean

Specifies whether to display a shimmer effect during scrolling in the virtual scrolling feature when enableVirtualization is enabled. If disabled, a spinner is shown instead of the shimmer effect.

Defaults to true

enableVirtualization boolean

If enableVirtualization is set to true, the Gantt chart will render only the rows visible within the viewport.
and load subsequent rows as the user scrolls vertically. This improves performance when dealing with large datasets.

Defaults to false

enableWBS boolean

Enables Work Breakdown Structure (WBS) functionality in the Gantt Chart.
When set to true, the Gantt Chart automatically generates WBS codes based on the task hierarchy.
A dedicated WBS Code column will be shown to represent the task structure.
Additionally, if task dependencies (predecessors) are mapped in the data source, a WBS Predecessor column will also be displayed to reflect dependency information using WBS codes.

Defaults to false

eventMarkers EventMarkerModel[]

Defines the events and milestones along the project timeline.
These event markers indicate significant events or milestones throughout the project’s duration.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, DayMarkers, EventMarkersDirective, EventMarkerDirective  } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.eventMarkerDay = new Date('4/10/2019');
    }
    render() {
        return <GanttComponent>
        <EventMarkersDirective>
            <EventMarkerDirective day={this.eventMarkerDay} cssClass='e-custom-event-marker' label='Project approval and kick-off'></EventMarkerDirective>
        </EventMarkersDirective>
        <Inject services={[DayMarkers]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to []

excelExportModule ExcelExport

The excelExportModule is used for exporting Gantt data to an Excel file.
This module provides the functionality to export task data, dependencies, and other Gantt-related information in Excel format.

filterModule Filter

The filterModule is used to manage and apply filtering operations in the Gantt chart.

filterSettings FilterSettingsModel

Configures the filter settings for the Gantt chart, enabling users to filter tasks based on specific columns or criteria.
The filterSettings property allows customization of filter behavior, such as which columns to filter and the filter type.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Filter } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.FilterSettings = {
            columns: [
                { field: 'TaskName', matchCase: false, operator: 'startswith', predicate: 'and', value: 'Identify' },
                { field: 'TaskID', matchCase: false, operator: 'equal', predicate: 'and', value: 2 }
            ],
            ignoreAccent: true
        };
    }
    render() {
        return <GanttComponent filterSettings={this.FilterSettings}>
        <Inject services={[Filter]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to {columns: [], type: ‘Menu’ }

frozenColumns number

Specifies the number of columns that should remain visible and fixed on the left side of the Gantt during horizontal scrolling.
This feature ensures key columns, such as identifiers, stay visible while users scroll through data.

Defaults to 0

gridLines GridLine

Configures the grid lines displayed in the TreeGrid and Gantt chart.
The gridLines property allows customization of the type of grid lines to be shown, either horizontal, vertical, both or none.

  • Both: Displays both horizontal and vertical grid lines.
  • None: Hides both horizontal and vertical grid lines.
  • Horizontal: Displays only horizontal grid lines.
  • Vertical: Displays only vertical grid lines.
  • Default: Adjusts line visibility based on the theme.

Defaults to ‘Horizontal’

height number|string

Defines the height of the Gantt component container.
The height property can be set to a specific value (in pixels or percentage) or set to ‘auto’ for automatic height adjustment based on content.

Defaults to ‘auto’

highlightWeekends boolean

If highlightWeekends is set to true, it highlights all weekend days in the week-day timeline mode.
This makes weekends visually distinct in the timeline view.

Defaults to false

holidays HolidayModel[]

Defines holidays within the project timeline, allowing you to mark specific dates as holidays.
This helps in accounting for non-working days in scheduling and task planning.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, DayMarkers, HolidaysDirective, HolidayDirective } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
    }
    render() {
        return <GanttComponent>
        <HolidaysDirective>
            <HolidayDirective from='04/10/2019' label='Local Holiday' cssClass='e-custom-holiday'><HolidayDirective>
        </HolidaysDirective>
        <Inject services={[DayMarkers]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to []

includeWeekend boolean

Specifies whether weekend days are considered working days in the Gantt chart.
When includeWeekend is set to true, weekends (Saturday and Sunday) are treated as regular working days.

Defaults to false

keyboardModule KeyboardEvents

The keyboardModule is responsible for managing keyboard interactions in the Gantt chart.
It handles events such as navigating, selecting, and performing actions using the keyboard.

labelSettings LabelSettingsModel

Configures the labels displayed on the right, left, and inside the taskbars in the Gantt chart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.labelSettings = {
            leftLabel: 'TaskID',
            rightLabel: 'Task Name: ${taskData.TaskName}',
            taskLabel: '${Progress}%'
        };
    }
    render() {
        return <GanttComponent labelSettings={this.labelSettings}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

loadChildOnDemand boolean

Gets or sets whether to load child records on demand in remote data binding. When loadChildOnDemand set to true, child records are loaded only when expanded, and parent records are rendered in a collapsed state initially.

Defaults to true

loadingIndicator LoadingIndicatorModel

Specifies the type of loading indicator to display during scrolling action in the virtual scrolling feature when enableVirtualization is enabled.

Defaults to {indicatorType: ‘Spinner’}

locale string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

Defaults to ’’

milestoneTemplate string|Function

Defines a custom template for rendering milestone tasks in the Gantt chart. This template allows you to customize the appearance of milestone tasks.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Filter,IGanttData } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
     MilestoneTemplate(props:IGanttData) {
    return (
      <div
        className="e-gantt-milestone"
        style={{
          width: '16px',
          height: '16px',
          position: 'absolute',
          transform: 'rotate(45deg)',
          left: '1px',
        }}
      ></div>
    );
  }
    }
    render() {
        return <GanttComponent milestoneTemplate={MilestoneTemplate} >
        <Inject services={[Filter]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to null

parentTaskbarTemplate string|Function

Defines a custom template for rendering parent task bars in the Gantt chart. This template allows you to customize the appearance of parent task bars.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Filter,IGanttData } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
     ParentTaskbarTemplate(props:IGanttData) {
    return (
      <div
        className="e-gantt-parent-taskbar-inner-div e-gantt-parent-taskbar"
        style={{ height: '100%' }}
      >
        <div
          className="e-gantt-parent-progressbar-inner-div e-row-expand e-gantt-parent-progressbar"
          style={{
            width: props.ganttProperties.progressWidth + 'px',
            height: '100%',
          }}
        ></div>
        <span
          className="e-task-label"
          style={{
            position: 'absolute',
            fontSize: '12px',
            color: 'white',
            top: '5px',
            left: '10px',
            fontFamily: 'Segoe UI',
            cursor: 'move',
          }}
        >
          {props.TaskName}
        </span>
      </div>
    );
  }
    }
    render() {
        return <GanttComponent parentTaskbarTemplate={ParentTaskbarTemplate} >
        <Inject services={[Filter]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to null

pdfExportModule PdfExport

The pdfExportModule is used for exporting the Gantt chart data to a PDF format.
This module provides functionality for exporting the entire chart or specific data to a PDF document.

projectEndDate Date|string

Defines the end date of the project. If the projectEndDate is not set, it will be automatically calculated based on the data source.
The date can be provided as a Date object or a string in a valid date format.

Defaults to null

projectStartDate Date|string

Defines the start date of the project. If the projectStartDate is not set, it will be automatically calculated based on the data source.
The date can be provided as a Date object or a string in a valid date format.

Defaults to null

query Query

Defines an external Query
that will be executed in conjunction with data processing to filter, sort the data.
This allows for advanced data manipulation before binding the data to the Gantt chart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
import { DataManager, Query, WebApiAdaptor } from '@syncfusion/ej2-data';

const dataSource = new DataManager({
    url: 'https://ej2services.syncfusion.com/production/web-services/api/GanttData',
    adaptor: new WebApiAdaptor(),
    crossDomain: true
});
// Create query with custom parameter (common pattern to signal "Gantt mode" to server)
const customQuery = new Query()
    .addParams('ej2Gantt', 'test');

const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentID'
};

const labelSettings = { leftLabel: 'TaskName' };

class App extends React.Component {
    render() {
        return (
            <GanttComponent
                dataSource={dataSource}
                query={customQuery}  // This is the key line — binds the query
                taskFields={taskFields}
                labelSettings={labelSettings}
                height="450px">
            </GanttComponent>
        );
    }
}

ReactDOM.render(<App />, document.getElementById('root'));

Defaults to null

readOnly boolean

If readOnly is set to true, the Gantt chart becomes read-only, meaning tasks and other elements cannot be edited.
This setting disables all editing features, including task updates, dependency management, and any editing acions.

Defaults to false

renderBaseline boolean

If renderBaseline is set to true, baselines will be rendered for tasks in the Gantt chart.
Baselines provide a visual reference to track the planned vs. actual progress of tasks.

Defaults to false

resourceFields ResourceFieldsModel

Defines the mapping properties to extract resource values, such as id, name, unit, and group from the resource collection in the Gantt chart.
This helps to map data from a custom resource collection to the appropriate fields for resource allocation.

resourceIDMapping string

Defines the mapping property to retrieve the resource ID value from the resource collection.
This is used to map the resource ID from the resource data to the Gantt chart for resource allocation.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';

const resources = [
    { resourceId: 1, resourceName: 'Martin' },
    { resourceId: 2, resourceName: 'Rose' }
];

const taskFields = { resourceInfo: 'resources' };

const resourceFields = {
    id: 'resourceId',     // Maps resource ID field → conceptually resourceIDMapping
    name: 'resourceName'  // Maps resource Name field → conceptually resourceNameMapping
};

ReactDOM.render(
    <GanttComponent
        dataSource={[
            { TaskID: 1, TaskName: 'Task 1', StartDate: new Date('2025-01-01'), Duration: 5, resources: [1] },
            { TaskID: 2, TaskName: 'Task 2', StartDate: new Date('2025-01-03'), Duration: 4, resources: [1, 2] }
        ]}
        taskFields={taskFields}
        resourceFields={resourceFields}
        resources={resources}
        labelSettings={{ rightLabel: 'resources' }}
    />,
    document.getElementById('root')
);

Defaults to null

resourceNameMapping string

Defines the mapping property to retrieve the resource name value from the resource collection.
This is used to map the resource name from the resource data to the Gantt chart for task allocation.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';

const resources = [
    { resourceId: 1, resourceName: 'Martin' },
    { resourceId: 2, resourceName: 'Rose' }
];

const taskFields = { resourceInfo: 'resources' };

const resourceFields = {
    id: 'resourceId',     // Maps resource ID field → conceptually resourceIDMapping
    name: 'resourceName'  // Maps resource Name field → conceptually resourceNameMapping
};

ReactDOM.render(
    <GanttComponent
        dataSource={[
            { TaskID: 1, TaskName: 'Task 1', StartDate: new Date('2025-01-01'), Duration: 5, resources: [1] },
            { TaskID: 2, TaskName: 'Task 2', StartDate: new Date('2025-01-03'), Duration: 4, resources: [1, 2] }
        ]}
        taskFields={taskFields}
        resourceFields={resourceFields}
        resources={resources}
        labelSettings={{ rightLabel: 'resources' }}
    />,
    document.getElementById('root')
);

Defaults to null

resources object[]

Specifies the collection of resources assigned to the project.

Defaults to []

rowDragAndDropModule RowDD

The rowDragAndDropModule manages the row reordering functionality in the Gantt chart.
It allows users to drag and drop rows to reorder tasks within the Gantt chart view.

rowHeight number

Defines the height of grid and chart rows in the Gantt chart.
This property sets the vertical space allocated for each task or row, allowing customization of row sizes.

Defaults to 36

searchSettings SearchSettingsModel

Configures the search functionality within the Gantt chart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Filter } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.searchSettings = {
            fields: ['TaskName'], operator: 'contains', key: 'Soil', ignoreCase: true, hierarchyMode: 'Parent'
        };
    }
    render() {
        return <GanttComponent searchSettings={this.searchSettings}>
        <Inject services={[Filter]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

segmentData object[]

Specifies the array of segment objects assigned to tasks in the Gantt chart.
Each segment represents a portion of the taskbar, allowing for visual representation of different phases or sub-tasks within a single task.

Defaults to []

selectedRowIndex number

The selectedRowIndex allows you to specify the index of the row to be selected at the time of initial rendering.
It can also be used to get the currently selected row index after selection.
A value of -1 indicates no row is selected.

Defaults to -1

selectionModule Selection

The selectionModule is used to manipulate selection operation in the Gantt chart.

selectionSettings SelectionSettingsModel

Configures the settings for selection in the Gantt chart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Selection  } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.selectionSettings = {
            mode: 'Row',
            type: 'Multiple'
        };
    }
    render() {
        return <GanttComponent selectionSettings={this.selectionSettings}>
        <Inject services={[Selection]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to {mode: ‘Row’, type: ‘Single’}

showColumnMenu boolean

If showColumnMenu set to true, enables the column menu options for each column header in the Gantt chart.

Defaults to false

showInlineNotes boolean

To show notes column cell values inside the cell or in tooltip.

Defaults to false

showOverAllocation boolean

If showOverAllocation set to true, enables the rendering of the overallocation container in the Gantt chart.

Defaults to false

sortModule Sort

The sortModule is used to manipulate sorting operation in Gantt.

sortSettings SortSettingsModel

Configures the sorting options for the Gantt chart.
When set, it defines how tasks are sorted based on the specified columns.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Sort } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.sortSettings = { columns: [{ field: 'TaskID', direction: 'Descending' }], allowUnsort: true };
    }
    render() {
        return <GanttComponent sortSettings={this.sortSettings}>
        <Inject services={[Sort]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to {columns:[]}

splitterSettings SplitterSettingsModel

Configures the splitter settings for the Gantt chart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.splitterSettings = {
            position: "50%",
            minimum: "200",
            separatorSize: 5,
            view: 'Default'
        };
    }
    render() {
        return <GanttComponent splitterSettings={this.splitterSettings}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

The position takes precedence over columnIndex when both defined.

taskFields TaskFieldsModel

Defines the mapping properties used to extract task-related values—such as ID, start date, end date, duration, and progress—from the data source.
This ensures that the Gantt chart correctly maps the provided data to the corresponding task fields and renders them accurately.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.taskFields = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            dependency: 'Predecessor',
            progress: 'Progress',
            baselineStartDate: 'BaselineStartDate',
            baselineEndDate: 'BaselineEndDate',
            durationUnit: 'DurationUnit',
            expandState: 'isExpand',
            indicators: 'Indicators',
            milestone: 'Milestone',
            notes: 'info',
            resourceInfo: 'resourceInfo',
            child: 'subtasks',
        };
    }
    render() {
        return <GanttComponent taskFields={this.taskFields}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

taskMode ScheduleMode

Specifies task schedule mode for a project.

Defaults to ‘Auto’

taskType TaskType

taskType Specifies the task type for task whether fixedUnit or fixedWork or fixedDuration.

  • fixedUnit: Sets the task type as fixedUnit.
  • fixedWork: Sets the task type as fixedWork.
  • fixedDuration: Sets the task type as fixedDuration.

Defaults to fixedUnit

taskbarHeight number

Defines height of the taskbar element in the Gantt chart.

Defaults to null

taskbarTemplate string|Function

The task bar template that renders customized child task bars from the given template.
This property allows users to define a custom template for rendering child task bars in the Gantt chart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Filter,IGanttData } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
      TaskbarTemplate(props:IGanttData) {
      return (
      <div
        className="e-gantt-child-taskbar-inner-div e-gantt-child-taskbar"
        style={{ height: '100%' }}
      >
        <div
          className="e-gantt-child-progressbar-inner-div e-gantt-child-progressbar"
          style={{
            width: props.ganttProperties.progressWidth + 'px',
            height: '100%',
          }}
        ></div>
        <span
          className="e-task-label"
          style={{
            position: 'absolute',
            fontSize: '12px',
            color: 'white',
            top: '5px',
            left: '10px',
            fontFamily: 'Segoe UI',
            cursor: 'move',
          }}
        >
          {props.TaskName}
        </span>
      </div>
    );
  }
    }
    render() {
        return <GanttComponent taskbarTemplate={TaskbarTemplate}>
        <Inject services={[Filter]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to null

timelineSettings TimelineSettingsModel

Configures timeline settings of Gantt.
Defines default timeline modes or customized top tier mode and bottom tier mode or single tier only.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.timelineSettings = {
            showTooltip: true,
            timelineUnitSize: 80,
            timelineViewMode: 'Week',
            updateTimescaleView: true,
            weekStartDay: 0,
            weekendBackground: 'red',
            topTier: {
                format: 'MMM dd, yyyy',
                unit: 'Week',
            },
            bottomTier: {
                unit: 'Day',
                format: 'EEE, dd',
                count: 1,
            }
        };
    }
    render() {
        return <GanttComponent timelineSettings={this.timelineSettings}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

timelineTemplate string|Function

Specifies the template used to render custom HTML content in timeline cells.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';

const TimelineTemplate = (props: any) => {
    return (
        <div style={{ textAlign: 'center', padding: '5px' }}>
            {props.value}
        </div>
    );
};

ReactDOM.render(
    <GanttComponent
        // ... dataSource, taskFields, etc.
        timelineTemplate={TimelineTemplate}
        height="450px"
    />,
    document.getElementById('root')
);

Defaults to null

timezone string

Specifies the time zone used for task date and scheduling calculations in the Gantt chart.
By default, the system or browser time zone is applied.
The time zone always affects internal date calculations (e.g., task start/end times, durations, and dependencies),
even in non-hour views. However, visible changes in timeline and task positions only appear when the timeline
includes an hour-level mode.

To see the time zone reflected in the UI, configure one of these:

  • timelineViewMode: 'Hour'
  • or topTier.unit: 'Day' + bottomTier.unit: 'Hour'

Without an hour view (e.g., only Day/Week/Month views), the chart looks unchanged, but Gantt chart uses the new time zone.

Use standard IANA time zone names (e.g., ‘Asia/Kolkata’, ‘UTC’, ‘America/New_York’).

Defaults to null

toolbar []

toolbar defines the toolbar items of the Gantt.
It contains built-in and custom toolbar items.
If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the Gantt’s toolbar.


The available built-in toolbar items are:

  • Add: Adds a new record.
  • Edit: Edits the selected task.
  • Update: Updates the edited task.
  • Delete: Deletes the selected task.
  • Cancel: Cancels the edit state.
  • Search: Searches tasks by the given key.
  • ExpandAll: Expands all the task of Gantt.
  • CollapseAll: Collapses all the task of Gantt.
  • PrevTimeSpan: Extends timeline with one unit before the timeline start date.
  • NextTimeSpan: Extends timeline with one unit after the timeline finish date.
  • ZoomIn: ZoomIn the Gantt control.
  • ZoomOut: ZoomOut the Gantt control.
  • ZoomToFit: Display the all tasks within the viewable Gantt chart.
  • ExcelExport: To export in Excel format.
  • CsvExport : To export in CSV format.
  • Indent: To indent a task to one level.
  • Outdent: To outdent a task from one level.

Defaults to null

tooltipSettings TooltipSettingsModel

Enables or disables default tooltip of Gantt element and defines customized tooltip for Gantt elements.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
         this.tooltipSettings = {
            showTooltip: true,
            taskbar: '<div>TaskID: ${TaskID}</div>',
            connectorLine: '<div>Offset : ${offsetString}</div>',
            editing: '<div>Duration : ${duration}</div>',
            baseline: '<div>Baseline StartDate : ${this.getFormatedDate(BaselineStartDate)}</div>'
        };
    }
    render() {
        return <GanttComponent tooltipSettings={this.tooltipSettings}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

Defaults to { showTooltip: true }

treeColumnIndex number

To define expander column index in Grid.

Defaults to 0

undoRedoActions GanttAction[]

undoRedoActions Defines action items that retain for undo and redo operation.

Defaults to [‘Sorting’, ‘Add’, ‘ColumnReorder’, ‘ColumnResize’, ‘ColumnState’, ‘Delete’, ‘Edit’, ‘Filtering’, ‘Indent’, ‘Outdent’, ‘NextTimeSpan’, ‘PreviousTimeSpan’, ‘RowDragAndDrop’, ‘TaskbarDragAndDrop’, ‘Search’, ‘ZoomIn’, ‘ZoomOut’, ‘ZoomToFit’]

undoRedoModule UndoRedo

The undoRedoModule manages the undo and redo functionality in the Gantt chart.

undoRedoStepsCount number

Specifies the number of undo and redo actions to retain in history.

Defaults to 10

updateOffsetOnTaskbarEdit boolean

Specifies whether to update offset value on a task for all the predecessor edit actions.

Defaults to true

validateManualTasksOnLinking boolean

If validateManualTasksOnLinking is set to true,
it enables date validation while connecting manually scheduled tasks with predecessor.

Defaults to false

viewType ViewType

Specifies the view type of the Gantt chart.

Defaults to ‘ProjectView’

virtualScrollModule VirtualScroll

The virtualScrollModule is used to handle virtual scroll in Gantt.

weekWorkingTime WeekWorkingTimeModel[]

Specifies the working days in a week for accurate planning, and works only when the timeline is configured with topTier.unit as ‘Day’ and bottomTier.unit as ‘Hour’ or when timelineViewMode is set to ‘Hour’ or ‘Day’.

width number|string

Defines the width of the Gantt component container.

Defaults to ‘auto’

workUnit WorkUnit

workUnit Specifies the work unit for each tasks whether day or hour or minute.

  • day: Sets the work unit as day.
  • hour: Sets the work unit as hour.
  • minute: Sets the work unit as minute.

Defaults to hour

workWeek string[]

Specifies the project’s workweek (working days).
workWeek specifies the days of the week that are considered working days for the project.

Defaults to [‘Monday’, ‘Tuesday’, ‘Wednesday’, ‘Thursday’, ‘Friday’]

zoomingLevels ZoomTimelineSettings[]

Defines the available zoom levels for the Gantt timeline.
Provide an array of ZoomTimelineSettings to control the scale and intervals used when zooming.

Defaults to []

Methods

addPredecessor

To add dependency for Task.

Parameter Type Description
id number | string Defines the ID of data to modify.
predecessorString string Defines the predecessor string to add.

Returns void

addRecord

Method to add record.

Parameter Type Description
data (optional) Object[] | IGanttData | Object Defines record to add.
rowPosition (optional) RowPosition Defines the position of row.
rowIndex (optional) number Defines the row index.

Returns void

autoFitColumns

Adjusts the width of specified columns to fit their content, preventing wrapping or truncation.
Hidden columns are ignored. For initial rendering, call this method during the dataBound event.

Parameter Type Description
fieldNames (optional) string | string[] The name(s) of the column(s) to auto-fit. Accepts a single column name or an array of column names.

Returns void

cancelEdit

Cancels the current edit operation and reverts the changes made during editing.

Returns void

changeTaskMode

To change the mode of a record.

Parameter Type Description
data Object Use to change the TaskMode either manual, auto or custom.

Returns void

clearFiltering

Clears the filtered columns in Gantt.
Can also be used to clear filtering of a specific column in Gantt.

Parameter Type Description
fields (optional) string[] Defines the specific column to remove filter.

Returns void

clearRedoCollection

Clears the stack collection for redo action.

Returns void

clearSelection

Deselects the current selected rows and cells.

Returns void

clearSorting

Clears all the sorted columns of the Gantt.

Returns void

clearUndoCollection

Clears the stack collection for undo action.

Returns void

collapseAll

Method to collapse all the rows of Gantt.

Returns void

collapseByID

Collapse the record by id value.

Parameter Type Description
id number | string Defines the id of task.

Returns void

collapseByIndex

Collapse the record by index value.

Parameter Type Description
index number Defines the index of row.

Returns void

convertToMilestone

Method to convert task data to milestone data.

Parameter Type Description
id string Defines id of record.

Returns void

csvExport

Export Gantt data to CSV file.

Parameter Type Description
excelExportProperties (optional) ExcelExportProperties Defines the export properties of the Gantt.
isMultipleExport (optional) boolean Define to enable multiple export.
workbook (optional) any Defines the Workbook if multiple export is enabled.
isBlob (optional) boolean If ‘isBlob’ set to true, then it will be returned as blob data.

Returns Promise

deleteRecord

Method to delete record.

Parameter Type Description
taskDetail number | string | number[] | string[] | IGanttData | IGanttData[] Defines the details of data to delete.

Returns void

enableItems

Enables or disables ToolBar items.

Parameter Type Description
items string[] Defines the collection of itemID of ToolBar items.
isEnable boolean Defines the items to be enabled or disabled.

Returns void

excelExport

Export Gantt data to Excel file(.xlsx).

Parameter Type Description
excelExportProperties (optional) ExcelExportProperties Defines the export properties of the Gantt.
isMultipleExport (optional) boolean Define to enable multiple export.
workbook (optional) any Defines the Workbook if multiple export is enabled.
isBlob (optional) boolean If ‘isBlob’ set to true, then it will be returned as blob data.

Returns Promise

expandAll

Method to expand all the rows of Gantt.

Returns void

expandByID

Expand the record by task id.

Parameter Type Description
id number | string Defines the id of task.

Returns void

expandByIndex

Expand the records by index value.

Parameter Type Description
index number[] | number Defines the index of rows to be expand.

Returns void

filterByColumn

Filters TreeGrid row by column name with the given options.

Parameter Type Description
fieldName string Defines the field name of the column.
filterOperator string Defines the operator to filter records.
filterValue string | number | Date | boolean | number[] | string[] | Date[] | boolean[] Defines the value
used to filter records.
predicate (optional) string Defines the relationship between one filter query and another by using AND or OR predicate.
matchCase (optional) boolean If match case is set to true, TreeGrid filters the records with exact match.if false, it filters case
insensitive records (uppercase and lowercase letters treated the same).
ignoreAccent (optional) boolean If ignoreAccent set to true,
then filter ignores the diacritic characters or accents while filtering.

Returns void

fitToProject

To show all project task in available chart width.

Returns void

getCriticalTasks

To get all the critical tasks in Gantt.

Returns IGanttData[]

getCurrentViewData

Retrieves the current view data, reflecting the latest state after filtering, sorting, and CRUD operations.

Returns Object[]

getDurationString

Get duration value as string combined with duration and unit values.

Parameter Type Description
duration number Defines the duration.
durationUnit string Defines the duration unit.

Returns string

getExpandedRecords

Get expanded records from given record collection.

Parameter Type Description
records IGanttData[] Defines record collection.

Returns IGanttData[]

getGanttColumns

Gets the Gantt columns.

Returns ColumnModel[]

getGridColumns

Gets the columns from the TreeGrid.

Returns Column[]

getRecordByID

Method to get record by id value.

Parameter Type Description
id string Defines the id of record.

Returns IGanttData

getRedoActions

To retrieve the collection of actions to reapply.
modifiedRecords - retrieves the modified records.
action - shows the current performed action such as ‘sorting’,’columnReorder’,’columnResize’,’progressResizing’,’rightResizing’,’leftResizing’,’add’,’delete’,’search’,’filtering’,’zoomIn’,’zoomOut’,’zoomToFit’,’columnState’,’previousTimeSpan’,’nextTimeSpan’,’indent’,’outdent’,’rowDragAndDrop’,’taskbarDragAndDrop’,’dialogEdit’

Returns Object[]

getRowByID

Method to get the row element by task id.

Parameter Type Description
id string | number Defines the id of task.

Returns HTMLElement

getRowByIndex

Method to get chart row value by index.

Parameter Type Description
index number Defines the index of row.

Returns HTMLElement

getTaskByUniqueID

Method to get task by uniqueId value.

Parameter Type Description
id string Defines the task id.

Returns IGanttData

getTaskInfo

Retrieves the internal Gantt properties for a task using its Task ID.
This method provides access to task data such as taskbar width, left position, segments collection etc.,.

Parameter Type Description
taskId string The unique identifier of the task.

Returns IGanttTaskInfo

getTaskbarHeight

Method to get taskbarHeight.

Returns number

getUndoActions

To retrieve the collection of previously recorded actions. This method returns an object as a collection that holds the following details.
modifiedRecords - retrieves the modified records.
action - shows the current performed action such as ‘sorting’,’columnReorder’,’columnResize’,’progressResizing’,’rightResizing’,’leftResizing’,’add’,’delete’,’search’,’filtering’,’zoomIn’,’zoomOut’,’zoomToFit’,’columnState’,’previousTimeSpan’,’nextTimeSpan’,’indent’,’outdent’,’rowDragAndDrop’,’taskbarDragAndDrop’,’dialogEdit’

Returns Object[]

getWorkString

Get work value as string combined with work and unit values.

Parameter Type Description
work number Defines the work value.
workUnit string Defines the work unit.

Returns string

hideColumn

Hides one or more columns in the Gantt chart based on the specified column names or header texts.

Parameter Type Description
keys string | string[] Defines a single or collection of column names.
hideBy (optional) string Defines the column key either as field name or header text.

Returns void

hideSpinner

Method used to hide spinner.

Returns void

indent

To indent the level of selected task to the hierarchical Gantt task.

Returns void

mergeTask

Merge the split taskbar with the given segment indexes.

Parameter Type Description
taskId number | string Defines the id of a task to be split.
segmentIndexes Object[] Defines the object array of indexes which must be merged.

Returns void

nextTimeSpan

To update timeline at end point with one unit.

Parameter Type Description
mode (optional) string Render next span of Timeline.

Returns void

openAddDialog

Method to open Add dialog.

Returns void

openEditDialog

Method to open Edit dialog.

Parameter Type Description
taskId (optional) number | string Defines the id of task.

Returns void

outdent

To outdent the level of selected task from the hierarchical Gantt task.

Returns void

pdfExport

Export Gantt data to PDF document.

Parameter Type Description
pdfExportProperties (optional) PdfExportProperties Defines the export properties of the Gantt.
isMultipleExport (optional) boolean Define to enable multiple export.
pdfDoc (optional) Object Defined the Pdf Document if multiple export is enabled.
isBlob (optional) boolean If the ‘isBlob’ parameter is set to true, the method returns PDF data as a blob instead of exporting it as a down-loadable PDF file. The default value is false.

Returns Promise

previousTimeSpan

Updates the Gantt timeline to the previous time span by one unit.

Parameter Type Description
mode (optional) string Render previous span of Timeline.

Returns void

redo

Initiates a redo action to reapply the most recent undone change performed.

Returns void

refreshColumns

Refreshes the column definitions and layout of the TreeGrid pane.
Applies any changes made to column configurations such as visibility, order, or width.
If refreshUI is set to true, the DOM is updated to reflect the latest column settings.

Returns void

removePredecessor

To remove dependency from task.

Parameter Type Description
id number | string Defines the ID of the task from which the dependency will be removed.

Returns void

removeSortColumn

To remove sorted records of particular column.

Parameter Type Description
columnName string Defines the sorted column name.

Returns void

reorderColumns

Changes the TreeGrid column positions by field names.

Parameter Type Description
fromFName string | string[] Defines origin field name.
toFName string Defines destination field name.

Returns void

reorderRows

Reorder the rows based on given indexes and position.

Parameter Type Description
fromIndexes number[] Defines the indexes of the dragged records.
toIndex number Defines the index where the dragged rows will be dropped.
position string Defines the position of the dropped row.

Returns void

scrollToDate

Scrolls the Gantt chart’s timeline horizontally to bring the specified date into view.
This method is useful for navigating directly to a task, milestone, or any specific time range.

Parameter Type Description
date string | Date The target date to scroll to. Accepts a date string or a JavaScript Date object.

Returns void

scrollToTask

To move horizontal scroll bar of Gantt to specific task id.

Parameter Type Description
taskId string Defines the task id of data.

Returns void

Method to perform search action in Gantt.

Parameter Type Description
keyVal string Defines key value to search.

Returns void

selectCell

Selects a cell by the given index.

Parameter Type Description
cellIndex IIndex Defines the row and column indexes.
isToggle (optional) boolean If set to true, then it toggles the selection.

Returns void

selectCells

Selects a collection of cells by row and column indexes.

Parameter Type Description
rowCellIndexes ISelectedCell[] Specifies the row and column indexes.

Returns void

selectRow

Selects a row by given index.

Parameter Type Description
index number Defines the row index.
isToggle (optional) boolean If set to true, then it toggles the selection.

Returns void

selectRows

Selects a collection of rows by indexes.

Parameter Type Description
records number[] Defines the collection of row indexes.

Returns void

setScrollTop

To set scroll top for chart scroll container.

Parameter Type Description
scrollTop number Defines scroll top value for scroll container.

Returns void

setSplitterPosition

Method to set splitter position.

Parameter Type Description
value string | number Define value to splitter settings property.
type string Defines name of internal splitter settings property.

Returns void

showColumn

Shows a column by its column name.

Parameter Type Description
keys string | string[] Defines a single or collection of column names.
showBy (optional) string Defines the column key either as field name or header text.

Returns void

showSpinner

Method used to show spinner.

Returns void

sortColumn

Sorts a column with the given options.

Parameter Type Description
columnName string Defines the column name to be sorted.
direction SortDirection Defines the direction of sorting field.
isMultiSort (optional) boolean Specifies whether the previous sorted columns are to be maintained.

Returns void

splitTask

Splits the taskbar of a specified task into segments based on the given date.

Parameter Type Description
taskId number | string Defines the id of a task to be split.
splitDate Date | Date[] Defines in which date the taskbar must be split up.

Returns void

undo

Initiates an undo action to revert the most recent change performed.

Returns void

updateChartScrollOffset

To update the horizontal (left) and vertical (top) scroll positions of the Gantt chart.

Parameter Type Description
left number Defines the scroll left value of chart side.
top number Defines the scroll top value of chart side.

Returns void

updateDataSource

Method to update data source.

Parameter Type Description
dataSource Object[] Defines a collection of data.
args object Defines the projectStartDate and projectEndDate values.

Returns void

updatePredecessor

To modify current dependency values of Task by task id.

Parameter Type Description
id number | string Defines the ID of data to modify.
predecessorString string Defines the predecessor string to update.

Returns void

updateProjectDates

To validate project start date and end date.

Parameter Type Description
startDate Date Defines start date of project.
endDate Date Defines end date of project.
isTimelineRoundOff boolean Defines project start date and end date need to be round off or not.
isFrom (optional) string Defines whether the call originates from a public method action or a taskbar editing action.

Returns void

updateRecordByID

Method to update record by ID.

Parameter Type Description
data Object Defines the data to modify.

Returns void

updateRecordByIndex

Method to update record by Index.

Parameter Type Description
index number Defines the index of data to modify.
data Object Defines the data to modify.

Returns void

updateTaskId

To update existing taskId with new unique Id.

Parameter Type Description
currentId number | string Defines the current Id of the record.
newId number | string Defines the new Id of the record.

Returns void

zoomIn

To perform Zoom in action on Gantt timeline.

Returns void

zoomOut

To perform zoom out action on Gantt timeline.

Returns void

Events

actionBegin EmitType<Object|FilterEventArgs|SortEventArgs|ITimeSpanEventArgs|IDependencyEventArgs|ITaskAddedEventArgs|ZoomEventArgs>

Event triggered when a Gantt action (sorting, filtering, searching, etc.) begins.
Allows cancellation or modification of the action.

actionComplete EmitType<FilterEventArgs|SortEventArgs|ITaskAddedEventArgs|IKeyPressedEventArgs|ZoomEventArgs>

Event triggered after a Gantt action (sorting, filtering, etc.) has completed.
Provides updated state after the action.

actionFailure EmitType<FailureEventArgs>

Event triggered when a Gantt action fails during execution.
Provides error details.

beforeDataBound EmitType<BeforeDataBoundArgs>

Event triggered before data is bound to the TreeGrid.
Allows modification of data before rendering begins.

beforeExcelExport EmitType<Object>

Event triggered before Gantt data is exported to Excel.
Allows modification or cancellation of the export process.

beforePdfExport EmitType<Object>

Event triggered before Gantt data is exported to PDF.
Allows modification or cancellation of PDF export.

beforeTooltipRender EmitType<BeforeTooltipRenderEventArgs>

Event triggered before a tooltip is rendered.
Allows customization of tooltip content or cancellation.

cellDeselected EmitType<CellDeselectEventArgs>

Event triggered after a cell has been deselected.

cellDeselecting EmitType<CellDeselectEventArgs>

Event triggered before a selected cell is deselected.
Allows cancellation of cell deselection.

cellEdit EmitType<CellEditArgs>

Event triggered when a cell enters edit mode in the Gantt chart.
Allows customization or cancellation of editing.

cellSave EmitType<CellSaveArgs>

Event triggered before a cell value is saved during editing.
Allows cancellation or modification of the save operation.

cellSelected EmitType<CellSelectEventArgs>

Event triggered after a cell has been selected.

cellSelecting EmitType<CellSelectingEventArgs>

Event triggered before a cell is selected.
Allows cancellation of cell selection.

collapsed EmitType<ICollapsingEventArgs>

Event triggered after a row has been collapsed.
Indicates the collapse action has completed.

collapsing EmitType<ICollapsingEventArgs>

Event triggered before a row is collapsed.
Allows cancellation of the collapse action.

columnDrag EmitType<ColumnDragEventArgs>

Event triggered continuously while a column header is being dragged.

columnDragStart EmitType<ColumnDragEventArgs>

Event triggered when column header drag starts.

columnDrop EmitType<ColumnDragEventArgs>

Event triggered when a dragged column header is dropped.

columnMenuClick EmitType<ColumnMenuClickEventArgs>

Event triggered when an item in the column menu is clicked.

columnMenuOpen EmitType<ColumnMenuOpenEventArgs>

Event triggered before the column menu is opened.
Allows customization or cancellation of menu display.

contextMenuClick EmitType<CMenuClickEventArgs>

Event triggered when an item in the context menu is clicked.

contextMenuOpen EmitType<CMenuOpenEventArgs>

Event triggered before the context menu is opened.
Allows customization or cancellation.

created EmitType<Object>

Event triggered after the Gantt component is fully created and initialized.

dataBound EmitType<Object>

Event triggered after the data source is bound to the TreeGrid part of Gantt.
Indicates data binding is complete.

dataSourceChanged EmitType<DataSourceChangedEventArgs>

Triggers when data in the Gantt is added, deleted, or updated.
Invoke the done method from the argument to start rendering after an edit operation.

dataStateChange EmitType<DataStateChangeEventArgs>

Event triggered after actions like sorting, filtering complete.
Used to update the dataSource with current view data and record count.

destroyed EmitType<Object>

Event triggered when the Gantt component is being destroyed.
Allows cleanup operations.

endEdit EmitType<ITaskbarEditedEventArgs>

Event triggered when a task is saved through cell editing.
Provides updated task data after save.

excelExportComplete EmitType<ExcelExportCompleteArgs>

Event triggered after Gantt data has been successfully exported to Excel.
Provides access to the generated workbook.

excelHeaderQueryCellInfo EmitType<ExcelHeaderQueryCellInfoEventArgs>

Event triggered before each header cell is exported to Excel.
Allows customization of header cell content or styling.

excelQueryCellInfo EmitType<ExcelQueryCellInfoEventArgs>

Event triggered before each cell (header or data) is exported to Excel.
Allows customization of cell content, style, or value.

expanded EmitType<ICollapsingEventArgs>

Event triggered after a row has been expanded.
Indicates the expand action has completed.

expanding EmitType<ICollapsingEventArgs>

Event triggered before a row is expanded.
Allows cancellation of the expand action.

headerCellInfo EmitType<HeaderCellInfoEventArgs>

Event triggered before each header cell element is rendered.
Allows customization of header cell content or style.

load EmitType<Object>

Event triggered when the Gantt component begins loading data.
Occurs before any rendering starts.

onMouseMove EmitType<IMouseMoveEventArgs>

Event triggered on mouse move over the Gantt component.
Provides mouse position and target information.

onTaskbarClick EmitType<ITaskbarClickEventArgs>

Event triggered when a taskbar element is clicked.
Provides task and click details.

pdfColumnHeaderQueryCellInfo EmitType<PdfColumnHeaderQueryCellInfoEventArgs>

Event triggered before each column header cell is exported to PDF.
Allows customization of header cell content or style.

pdfExportComplete EmitType<Object>

Event triggered after Gantt data has been exported to PDF.
Provides access to the generated document.

pdfQueryCellInfo EmitType<PdfQueryCellInfoEventArgs>

Event triggered before each cell is exported to PDF.
Allows customization of cell content or style.

pdfQueryTaskbarInfo EmitType<Object>

Event triggered before each taskbar is exported to PDF.
Allows customization of taskbar appearance in PDF.

pdfQueryTimelineCellInfo EmitType<PdfQueryTimelineCellInfoEventArgs>

Event triggered before each timeline cell is exported to PDF.
Allows customization of timeline cell content or style.

queryCellInfo EmitType<QueryCellInfoEventArgs>

Event triggered before each cell element is rendered.
Allows customization of cell content or style.

queryTaskbarInfo EmitType<IQueryTaskbarInfoEventArgs>

Event triggered per taskbar before rendering in the Gantt chart.
Used to customize taskbar styles and properties dynamically.

recordDoubleClick EmitType<RecordDoubleClickEventArgs>

Event triggered when a record is double-clicked.

resizeStart EmitType<ResizeArgs>

Event triggered when column resizing starts in the Grid.

resizeStop EmitType<ResizeArgs>

Event triggered when column resizing completes.

resizing EmitType<ResizeArgs>

Event triggered continuously while a column is being resized.

rowDataBound EmitType<RowDataBoundEventArgs>

Event triggered before each row element is rendered.
Allows customization of row appearance.

rowDeselected EmitType<RowDeselectEventArgs>

Event triggered after a row has been deselected.

rowDeselecting EmitType<RowDeselectEventArgs>

Event triggered before a selected row is deselected.
Allows cancellation of deselection.

rowDrag EmitType<RowDragEventArgs>

Event triggered continuously while row elements are being dragged.
Provides current drag position and target information.

rowDragStart EmitType<RowDragEventArgs>

Event triggered when a row drag operation starts.
Provides initial drag source details.

rowDragStartHelper EmitType<RowDragEventArgs>

Event triggered before the row drag operation officially begins.
Allows preparation or cancellation of the drag action.

rowDrop EmitType<RowDragEventArgs>

Event triggered when dragged row elements are dropped onto a target row.
Provides source and target row information for reordering/indent/outdent.

rowSelected EmitType<RowSelectEventArgs>

Event triggered after a row has been selected.

rowSelecting EmitType<RowSelectingEventArgs>

Event triggered before a row is selected.
Allows cancellation of selection.

splitterResizeStart EmitType<ResizeEventArgs>

Event triggered when splitter resizing begins in the Gantt component.

splitterResized EmitType<ISplitterResizedEventArgs>

Event triggered when splitter resizing action completes.

splitterResizing EmitType<ResizingEventArgs>

Event triggered continuously while the splitter bar is being dragged.

taskbarEdited EmitType<ITaskbarEditedEventArgs>

Event triggered after a taskbar has been dragged and dropped to a new position.
Indicates editing via taskbar has completed.

taskbarEditing EmitType<ITaskbarEditedEventArgs>

Event triggered while a taskbar is being dragged.
Provides current drag progress and position.

toolbarClick EmitType<ClickEventArgs>

Event triggered when a toolbar item is clicked.